<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Entity\FpaitecalcfolhaEntity;
use HCM\FPA\Entity\FpaPtregraEntity;
use HCM\FPA\Entity\FpatipomovimentEntity;
use HCM\FPA\Entity\FpagozoferiasEntity;
use HCM\FPA\Entity\FpaferiasEntity;
use HCM\FPA\Entity\FpaParamfolhahEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpaFormcalculoEntity;
use HCM\FPA\Entity\FpatipoferiasmEntity;
use HCM\FPA\Entity\FpaTpdemissaoEntity;
use HCM\FPA\Entity\FpaProcessoEntity;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\FPA\Entity\FpafaltaferiasEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpaRegramEntity;
use HCM\FPA\Entity\FpaValorreferenciamEntity;
use HCM\FPA\Entity\FpatipoincideEntity;
use HCM\FPA\Entity\FpaGrpitemEntity;
use HCM\Geral\Entity\GpevinculomEntity;
use HCM\Geral\Entity\GpevinculohEntity;
use HCM\Geral\Entity\GpealtesitufuncEntity;
use HCM\Geral\Entity\GpesitufunchEntity;
use HCM\Geral\Entity\GpesitufuncmEntity;
use HCM\Geral\Entity\GpeescalatrabhEntity;
use HCM\Geral\Entity\GpealtesalarioEntity;
use HCM\Geral\Entity\GpeParamoperEntity;
use HCM\FPA\Entity\FpaTpcalcregraEntity;
use HCM\FPA\Calculos\Geral\CalculoRegra;
use HCM\Util\DateUtil;
use HCM\FPA\Calculos\Geral\MemoriaCalculo;

class Preparacao{

    private $_simulacao;
    private $_parametros;
    private $_nrorg;
    private $_nrOrgPadrao;
    private $_nrTipoModalidadeCalc;
    private $_nrOcorrenciaCalc;
    private $_nr_tipo_calculo;
    private $_jornada_diaria; 
    private $_jornada_semanal;
    private $_mes_competencia;
    private $_mes_competencia_int;
    private $_id_retrocesso;
    private $_dtInicio;
    private $_dtFim;
    private $_dtPagamento;
    private $_inicio_periodo_aviso;
    private $_fim_periodo_aviso;
    private $_nr_dias_aviso;
    private $_nr_compl_dias_aviso;
    private $_12_meses_atras;  
    private $_divisor_aviso;
    private $_indeniza_complemento;
    private $_dt_fim_exp1; 
    private $_dt_fim_exp2;
    private $_nr_dias_faltas;
    private $_inicio_periodo_13sal;
    private $_fim_periodo_13sal;
    private $_ultimo_dia_mes;
    private $_primeiro_dia_ano;
    private $_ultimo_dia_ano;
    private $_nr_doze_avos;
    private $_nr_compl_doze_avos;
    private $_divisor_13;
    private $_id_media_1p13;
    private $_percentual_adiantamento = 50;
    private $_inicio_periodo_saida;
    private $_fim_periodo_saida;
    private $_tipo_ferias;
    private $_ferias;
    private $_gozo_ferias;
    private $_aviso_previo;
    private $_media_mensal;
    private $_ferias_vencidas;
    private $_ferias_proporcionais;
    private $_divisor_ferias;
    private $_decimo_terceiro_sal;
    private $_dt_retorno_ferias;
    private $_dt_ini_prox_periodo;
    private $_ds_ferias_coletivas;
    private $_nr_situ_func;
    private $_id_ferias_coletivas;
    private $_divisor_media_mensal;
    private $_itens_calculo_principal;
    private $_itens_aviso_previo;
    private $_itens_ferias_vencidas;
    private $_itens_ferias_proporcionais;
    private $_itens_13sal;
    private $_itens_media_mensal;
    private $_calculo_folha;
    private $_assoc_eventos;
    private $_eventom;
    private $_eventomMedia;
    private $_vinculom;
    private $_pessoa;
    private $_escalam; 
    private $_situacao_funcional;
    private $_alteracao_situacao_funcional;
    private $_media;
    private $_paramCalculo;
    private $_vrPercentAdiant13Sal;
    private $_nrDiasFeriasProvisao;
    private $_faltas_intervalo;
    private $_divisor_fixo;
    private $_iddesccompetenc;
    private $_diasGozados;
    private $nrVinculom;
    private $_idDesconsidera1Parc13;
    
    public function __construct($entityManager, $hcmParameters, $dataSet, $nr_tp_calculo, $simulacao, $dtmescompetenc = null) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_nrorg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        
        if ($dtmescompetenc) {
            $this->_mes_competencia = $dtmescompetenc;
            $this->_mes_competencia_int = $this->_mes_competencia->format('m');
        } else {
            $this->_mes_competencia = DateUtil::getDataDeString($hcmParameters->getDtCompetencia());
            $this->_mes_competencia_int = $this->_mes_competencia->format('m');
        }
        
        $this->_nrTipoModalidadeCalc = $hcmParameters->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalc = $hcmParameters->getNrOcorrenciaCalculo();
        $this->_dt_pagamento = $dataSet['DTPAGAMENTO'];
        $this->_simulacao = $simulacao;
        $this->_nr_tipo_calculo = $nr_tp_calculo;
        
        $this->_primeiro_dia_ano = DateUtil::getPrimeiroDiaDoAno($this->_mes_competencia);
        $this->_ultimo_dia_ano = DateUtil::getUltimoDiaDoAno($this->_mes_competencia);
        
                
        switch ($this->_nr_tipo_calculo)
        {
            case FpatipocalculoEntity::CALC_FERIAS:
                $this->_gozo_ferias = TkDI::getContainer()->gozo_ferias;
                $this->_dtInicio = $dataSet['DTINIGOZOINI'];
                $this->_dtFim = $dataSet['DTINIGOZOFIM'];
                
                if(!$this->_dtInicio){
                    $this->_dtInicio = DateUtil::getDataDeString(substr($dataSet['DTINIGOZOFERIAS'],0, 10));
                }
                if(!$this->_dtFim){
                    $this->_dtFim = DateUtil::getDataDeString(substr($dataSet['DTFIMGOZOFERIAS'],0, 10));
                }
                
                $this->_inicio_periodo_saida = DateUtil::getDataDeString(substr($this->_dtInicio, 0, 10));
                $this->_fim_periodo_saida = DateUtil::getDataDeString(substr($this->_dtFim, 0, 10));
                
                break;
            case FpatipocalculoEntity::CALC_RESCISAO:
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
            case FpatipocalculoEntity::CALC_PROVISAO_OTIMIZADA:
                $this->_ultimo_dia_mes = DateUtil::getUltimoDiaDoMes($this->_mes_competencia);
                $this->_12_meses_atras = DateUtil::subtraiIntervalo($this->_mes_competencia, 11, DateUtil::MES);
                break;
        }

        $this->_media = new MediaEventosIntervalo($entityManager, $hcmParameters, $this->_dt_pagamento);

        $this->_eventomMedia = new FpaeventomEntity(
            $entityManager, $hcmParameters, $this->_dt_pagamento
        );
        $this->_divisor_fixo = $entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'VR_DIVISOR_FIXO');
        $this->_alteracaoSalario = new GpealtesalarioEntity($entityManager, $hcmParameters);
        
        $this->_ferias = TkDI::getContainer()->ferias;
        $this->_vinculom = TkDI::getContainer()->vinculom;
        $this->_pessoa = TkDI::getContainer()->pessoa;
        $this->_assoc_eventos = TkDI::getContainer()->assoc_eventos;
        $this->_eventom = TkDI::getContainer()->eventom;
        $this->_escalam = TkDI::getContainer()->escalam;
        $this->_situacao_funcional = TkDI::getContainer()->situacao_funcional;
        $this->_alteracao_situacao_funcional = TkDI::getContainer()->alteracao_situacao_funcional;
        $this->_calculo_folha = TkDI::getContainer()->calculo_folha;
        $this->_paramCalculo = TkDI::getContainer()->param_calculo;
        $this->_faltas_intervalo = TkDI::getContainer()->faltas_intervalo;
        $this->_valores_referencia = new FpaValorreferenciamEntity($entityManager, $hcmParameters);
        
    }

    public function preparar($vinculo, $tp_calc_mov, $contador){
        $this->_inicializaVariaveis($vinculo);
        
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            return;
        }
        
        $this->nrVinculom = $vinculo->getNrvinculom();
        
        $this->setaValorTipoSalario($vinculo, $this->_mes_competencia);
        
        try{
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
            $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_calculo_principal->setNrTipoCalculo($this->_nr_tipo_calculo);
            $this->_itens_calculo_principal->setNrvinculom($this->nrVinculom);
        } catch(Exception $e){
            $message = $e->getMessage().' - Principal PREPARACAO.PHP';
            throw new Exception($message);
        }

        if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FECHAMENTO &&
            $this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );
            if ($liquido === true) {
                return false;
            }
        }

        $liquidoParcial = $this->_itens_calculo_principal->verificaLiquidoParcial(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        if ($liquidoParcial === true) {
            $this->_itens_calculo_principal->executaRetrocesso($this->_eventom);
        }
        
        if($this->_id_ferias_coletivas==true) {
            $this->_verificaFeriasColetivas($vinculo, $this->_inicio_periodo_saida, $this->_fim_periodo_saida, $this->_dt_retorno_ferias,
                $this->_dt_ini_prox_periodo, $this->_ds_ferias_coletivas,$this->_nr_situ_func);
            return;
        }
        $this->_executaPreparacaoEspecifica($vinculo, $tp_calc_mov);
        
        if ($this->_simulacao === false) {

            if($this->existeDesconto131ParcAnterior(
                $tp_calc_mov->retornaListaItensCalculo($this->_mes_competencia, $this->_eventom, $vinculo),
                $this->_nr_tipo_calculo, FpatipocalculoEntity::CALC_ADIANT_13SAL, $this->_idDesconsidera1Parc13
            ) == true){
                return true;
            }
            
            $tp_calc_mov->persisteItensCalculo();
        } else {
            
            if($this->existeDesconto131ParcAnterior(
                $tp_calc_mov->retornaListaItensCalculo($this->_mes_competencia, $this->_eventom, $vinculo),
                $this->_nr_tipo_calculo, FpatipocalculoEntity::CALC_ADIANT_13SAL, $this->_idDesconsidera1Parc13
            ) == true){
                return true;
            }

            $lista = $tp_calc_mov->retornaListaItensCalculo(
                $this->_mes_competencia, $this->_eventom, $elementoDemonstrativo
            );
        }
        return $this->nrGozoFerias;

    }
    
    public function existeDesconto131ParcAnterior($itenscalc, $nrtipocalc, $nrtipocalcentity, $iddesconsidera1parc13){
        if(!empty($itenscalc)){
            foreach($itenscalc as $itens){
                foreach($itens as $item){
                    if(($item['NREVENTOM'] == 1500 && $nrtipocalc == $nrtipocalcentity) && $iddesconsidera1parc13 == 'S'){
                        return true;
                    }
                }
            }
        }
    }
    
    public function setaValorTipoSalario($vinculo, $dataLimite){
        
        if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
            $nrModalidade = $vinculo->historico->getNrtpmodalidsal();
        } else {
            $nrModalidade = $this->hcmParameters->getTipoModalidadeSalario();
        }
        $this->_dataBaseDissidio = null;
        $carregou = $this->_alteracaoSalario->carregaAlteracaoSalario($dataLimite,  $vinculo->getNrvinculom(), $nrModalidade);
        if ($carregou) {
            $this->_salario = $this->_alteracaoSalario->getSalario();
            /*$this->_tipoSalario = $this->_alteracaoSalario->getTipoSalario();
            $this->_tipoAltSal = $this->_alteracaoSalario->getTipoAlteSal();
            $this->_dataDissidio = $this->_alteracaoSalario->getDtalterasalario();
            
            if($this->_tipoAltSal==GpealtesalarioEntity::ALTERACAO_SALARIO_DISSIDIO||
			    $this->_tipoAltSal==5||
				$this->_tipoAltSal==9){
                if ($this->_alteracaoSalario->getDataBaseDissidio() != null) {
                    $this->_dataBaseDissidio= DateUtil::getDataDeString($this->_alteracaoSalario->getDataBaseDissidio());
                }
            }*/
        } 
        
    }
    
    private function _executaPreparacaoEspecifica($vinculo, $tp_calc_mov){

        switch($this->_nr_tipo_calculo){
            case FpatipocalculoEntity::CALC_ADIANT_PLR:
            case FpatipocalculoEntity::CALC_PLR:
                $this->_analisaPLR($vinculo,$this->_itens_calculo_principal);
                break;
            case FpatipocalculoEntity::CALC_13SAL:
            case FpatipocalculoEntity::CALC_ADIANT_13SAL:
                $this->_analisa13Sal($vinculo, $this->_itens_calculo_principal);
                break;
            case FpatipocalculoEntity::CALC_FERIAS:
                
                $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_FERIAS_13SAL;
                try {
                    $obj_tp_calc_mov = current(
                        $tp_calc_mov->retornaPosicaoTpMov($this->_decimo_terceiro_sal)
                    );
                    $this->_itens_13sal = $obj_tp_calc_mov->getInstancia();
                    $this->_itens_13sal->setNrvinculom($this->nrVinculom);
                } catch (Exception $e) {
                    $message = $e->getMessage();
                    $message .= ' - 13 Salário nas Férias PREPARACAO.PHP';
                    MsgCalculo::getInstance()->adicionaMensagem('13º Salário - ' . $e->getMessage());
                }
                
                $this->_analisa13Sal($vinculo, $this->_itens_13sal);
                $this->_analisaFerias($vinculo);
                break;
            case FpatipocalculoEntity::CALC_RESCISAO:
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:

                try {
                    $this->_atribuiIteCalcEspecificoRescisao($tp_calc_mov);
                } catch(Exception $e){
                    throw $e;
                }
                
                $this->_nr_dias_aviso = 0;
                $this->_nr_compl_dias_aviso = 0;
                
                if($this->_nr_tipo_calculo!=FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                    $this->_analisaFimContrato($vinculo, $this->_itens_calculo_principal);
                }
                
                $this->_analisaFeriasRescisaoProvisao($vinculo, $tp_calc_mov);
                $this->_analisa13Sal($vinculo, $this->_itens_13sal);
                if($this->_nr_tipo_calculo!=FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
                    $this->_analisaMediaMensal($vinculo,$this->_itens_media_mensal);
                    $this->_analisaFgts($vinculo,$this->_itens_calculo_principal);
                }
                break;
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:

                try {
                    $this->_atribuiIteCalcEspecificoProvisao($tp_calc_mov);
                } catch(Exception $e){
                    throw $e;
                }
                $divisorFixoProv = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'VR_DIV_FIXO_PROVISAO');
                if($divisorFixoProv){
                    $this->_analisa13SalFeriasProvisao($vinculo, $this->_itens_13sal);
                }else{
                    $this->_analisaFeriasProvisao($vinculo, $tp_calc_mov);
                    $this->_analisa13SalProvisao($vinculo, $this->_itens_13sal);
                }

                break;
            default:
                MsgCalculo::getInstance()->adicionaMensagem('Nr Tipo de calculo invalido',MsgCalculo::ERRO,true);
        }
    }

    public function retroceder(GpevinculomEntity $vinculo, FpatpcalcmovEntity $tp_calc_mov){

        if($this->_id_ferias_coletivas==true) {
            $despreparaCalculo=false;
            $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
            $itemDeGozo = $this->_gozo_ferias->procuraGozoFerias($this->_inicio_periodo_saida);

            if(is_object($itemDeGozo)){
                if($itemDeGozo->getDsgozoferias() == $this->_ds_ferias_coletivas){
                    $despreparaCalculo=true;
                }
            }
            $this->_cancelaFeriasColetivas($vinculo, $this->_inicio_periodo_saida, $this->_fim_periodo_saida, $this->_dt_retorno_ferias,
                $this->_ds_ferias_coletivas);

            if($despreparaCalculo==false){
                return;
            }

        }

        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            throw new Exception($vinculo->getNrvinculom().' Não encontrou itens de calculo - PREPARACAO');
        }
        $this->_retrocesso($tp_calc_mov);

    }

    private function _retrocesso(FpatpcalcmovEntity $tp_calc_mov){
        $tp_calc_mov->apagaItensCalculo();
    }

    private function _inicializaVariaveis($vinculo){
        
        $nrEscala =$vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            return;
        }
        
        $escala = $this->_escalam->retornaEscalaNrEscala($nrEscala, $this->_nrorg);
        if ($escala->historico) {
            $this->_jornada_diaria = $escala->historico->getQthrescalatrabh();
        } else {
            $msg = 'Vinculo '.$vinculo->getNrvinculom().' sem historico para a escala de trabalho. ';
           
            $this->_jornada_diaria = 7.3333333;
            MsgCalculo::getInstance()->adicionaMensagem($msg);
        }
        if ($escala->historico) {
            $this->_jornada_semanal=$escala->historico->getQthrsemesctrabh();
        } else {
            $msg = 'Vinculo '.$vinculo->getNrvinculom().' sem historico para a escala de trabalho (jornada semanal). ';
            $this->_jornada_semanal= 44;
            MsgCalculo::getInstance()->adicionaMensagem($msg);
        }

        if($this->_jornada_semanal==null){
            $this->_jornada_semanal = 44;
        }
        $nrEstrutura = $vinculo->historico->getNrestrutlegal();
        if ($nrEstrutura === null) {
            $this->_nrCalendario = null;
            $msg = 'Vinculo '.$vinculo->getNrvinculom().' sem parametrizacao de Estrutura Legal. ';
            $msg .= '<br/> Preparacao nao executada.';
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem parametrização de Estrutura Legal.');
            return;
        }
        
        $this->_paramCalculo->carregaParametroEstrutura($nrEstrutura);
        
        $this->_carregaParametroFolha();
        
        $this->_carregaParametroFerias();

    }

    private function _carregaParametroFerias() {

        try{
            $this->_paramCalculo->carregaParametroFerias();

            $paramFerias = $this->_paramCalculo->getParamFerias();

            if (is_object($paramFerias) === true) {
                $this->_vrPercentAdiant13Sal = $paramFerias->getPercentualAdiantamento13Salario();
                $this->_nrDiasFeriasProvisao = $paramFerias->getNrDiasFeriasProvisao();
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parametro de Férias parametrizado no Parametro da Estrutura.');
            }
        } catch (Exception $e){
            throw $e;
        }
    }

    private function _carregaParametroFolha() {

        try{
            $this->_paramCalculo->carregaParametroFolha();

            $paramFolha = $this->_paramCalculo->getParamFolha();
            if (is_object($paramFolha)) {
                $this->_iddesccompetenc = $paramFolha->getIdDesconsideraCompetencia();
                $this->_id_media_1p13 = $paramFolha->getIdConsideraMedia1p13();
                $this->_idDesconsidera1Parc13 = $paramFolha->getDesconsidera1Parcela13CasoAdiantamentoAntecipado();
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Nao encontrado Parametro de Folha parametrizado no Parametro da Estrutura.');
            }
        } catch (Exception $e){
            throw $e;
        }
    }

    private function _analisaAvisoPrevio($vinculo, $itens_calculo){
        
        $this->_indeniza_complemento = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'INDEN_COMPL_AVISO_TRAB');
        
        $this->_verificaAvisoPrevio($vinculo, $itens_calculo);

        if ($this->_nr_dias_aviso > 0 || ($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso > 0 && $this->_indeniza_complemento!=false)) {
           $this->_inicio_periodo_aviso = DateUtil::setDay($this->_inicio_periodo_aviso, 1);

            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
            if(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                    || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) && $this->_iddesccompetenc == 'S') {
                
                $dataAuxiliar = DateUtil::subtraiIntervalo($this->_fim_periodo_aviso, 1, DateUtil::MES);
                
                $dataAuxiliarInicio = DateUtil::subtraiIntervalo($this->_inicio_periodo_aviso, 1, DateUtil::MES);
                
                $aux_inicioperiodo = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
                
                if($dataAuxiliarInicio < $aux_inicioperiodo){
                    $dataAuxiliarInicio = DateUtil::setDay($aux_inicioperiodo, 1);
                }
            } else {
                $dataAuxiliar = $this->_fim_periodo_aviso;
                $dataAuxiliarInicio = $this->_inicio_periodo_aviso;
            }
            
            $inicio_periodo = $dataAuxiliarInicio;
            $fim_periodo = $dataAuxiliar;
            
            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
            
            if($idMediaUltMes == 1) {
                $nrSindicato = $vinculo->historico->getNrestrutsind();
                if ($nrSindicato) {
                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                        $fim_periodo = $this->_mes_competencia;
                        
                        if($this->_iddesccompetenc == 'S'){
                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                        }else{
                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                        }
                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                    }
                }
            }
            
            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo,
                $fim_periodo, 1, null
            );
            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
            
            $this->_divisor_aviso =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
            if($this->_divisor_fixo!=false ){
                $this->_divisor_aviso = $this->_divisor_fixo;
            }
            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC,
                true,$this->_divisor_aviso
            );
        }
    }
    
    private function _analisaPLR($vinculo, $itens_calculo){
        $this->_verificaPLR($vinculo, $itens_calculo);
        
        $evento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PLR, $this->_eventom, $this->_nrorg
        );
    }

    private function _analisaMediaMensal($vinculo, $itens_calculo)
    {
        if ($this->_nrorg==20){
            $fimperiodo = DateUtil::getUltimoDiaDoMes($vinculo->getDtrescisaovinc());
            $inicioperiodo = DateUtil::setDay(DateUtil::subtraiIntervalo($vinculo->getDtrescisaovinc(), 11, DateUtil::MES), 1);
            $aux_inicioperiodo = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
            if($inicioperiodo < $aux_inicioperiodo){
                $inicioperiodo = DateUtil::setDay($aux_inicioperiodo, 1);
            }
            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
            if($this->_iddesccompetenc == 'S') {
                $fimperiodo = DateUtil::subtraiIntervalo($fimperiodo, 1, DateUtil::MES);
                $inicioperiodo = DateUtil::subtraiIntervalo($inicioperiodo, 1, DateUtil::MES);
                $aux_inicioperiodo = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
                if($inicioperiodo < $aux_inicioperiodo){
                    $inicioperiodo = DateUtil::setDay($aux_inicioperiodo, 1);
                }
            }

            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicioperiodo,
                $fimperiodo, 1, null
            );
            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
            
            $this->_divisor_media_mensal =  $this->_calculaDivisorMedias($inicioperiodo,$fimperiodo);
            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MEDIA_MENSAL,
                true, $this->_divisor_media_mensal
            );
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_MENSAL, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->geraEvento($evento, null, 0, 0, 1);
        }
    }

    private function _analisaFgts($vinculo, $itens_calculo)
    {
        if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::SEM_JUSTA_CAUSA_EMPREGADOR ||
            $vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ACORDO_ENTRE_PARTES ||     
            $vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ANTECIPACAO_EMPREGADOR
        ){
            $inicioperiodo = DateUtil::setDay($vinculo->getDtadmissaovinc(), 1);
            
            $fimperiodo = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());

            $eventoFgtsMensal = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FGTS, $this->_eventom, $this->_nrorg
            );

            $listaEventosTotalizados = $this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoFgtsMensal->getNreventom(), $inicioperiodo,
                $fimperiodo, 1, null
            );

            $eventoFgts13 = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FGTS_13SAL, $this->_eventom, $this->_nrorg
            );
            $listaEventosTotalizados13 = $this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_13SAL, $eventoFgts13->getNreventom(), $inicioperiodo,
                $fimperiodo, 1, null
            );

            $listaEventosTotalizados['2010']['VAL']+=$listaEventosTotalizados13['2020']['VAL'];
            $eventoFgtsSaldo = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_eventom, $this->_nrorg
            );
            $listaEventosOrigemDestino = array_combine(array($eventoFgtsMensal->getNreventom()),array($eventoFgtsSaldo->getNreventom()));

            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                true, 1
            );
        }
    }

    private function _analisa13SalProvisao($vinculo, $itens_calculo){

        $dt_admissao = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());

        $dt_rescisao = $vinculo->getDtrescisaovinc();

        if (empty($dt_rescisao) === false) {
            $dt_rescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        } else {
            $dt_rescisao = null;
        }

        $this->_atribuiInicioPeriodo13Salario($dt_admissao);

        $this->_verificaDecimoTerceiroCalculoProvisao($dt_rescisao);

        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        
        $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(
            array('nrorg' => $vinculo->getNrorg(), 'nrestruturam' => $vinculo->historico->getNrestrutsind()));
            
        if(is_object($fpaparamsindicato)) {
            $diasminimo = $fpaparamsindicato->getNrdiv13antecip();
        } else {
            $diasminimo = 15;
        }

        $dtfinal = DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual(true));

        $this->_divisor_13 = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $dtfinal, $diasminimo);
        $this->_nr_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
        );
        
        if ($this->_nr_doze_avos > 0) {
            switch($this->_nr_tipo_calculo){
                case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_RESC, $this->_eventom, $this->_nrorg
                    );

                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
            
                        break;
                default:
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Calculo '.$this->_nr_tipo_calculo.' não tratado.',MsgCalculo::ERRO,true);
            }
            $this->_inicio_periodo_13sal = DateUtil::setDay($this->_inicio_periodo_13sal, 1);
            
            if( $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL

            ){
                $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                if (((int)$this->_fim_periodo_13sal->format('m') == 12) and ($this->_nrOcorrenciaCalc > 1)) {
                    $dataAuxiliar = $this->_fim_periodo_13sal;
                }else {
                    $dataAuxiliar = $this->_fim_periodo_13sal;
                }
                
                $inicio_periodo = $this->_inicio_periodo_13sal;
                $fim_periodo = $dataAuxiliar;
                
                $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                
                if($idMediaUltMes == 1) {
                    $nrSindicato = $vinculo->historico->getNrestrutsind();
                    if ($nrSindicato) {
                        $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                        if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                            $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                            $fim_periodo = $this->_mes_competencia;
                            
                            if($this->_iddesccompetenc == 'S'){
                                $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                            }else{
                                $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                            }
                    
                            $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                            $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                        }
                    }
                }
                
                $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                    $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo,
                    $fim_periodo, 1, null
                );
                $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                
                $this->_divisor_13 =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                if($this->_divisor_fixo){
                    $this->_divisor_13 = $this->_divisor_fixo;
                }
                
                $this->_media->geraEventoMedia(
                    $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                    true, $this->_divisor_13
                );
            }
        }
    }
    
    private function _analisa13SalferiasProvisao($vinculo, $itens_calculo){

        $dt_admissao = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());

        $dt_rescisao = $vinculo->getDtrescisaovinc();

        if (empty($dt_rescisao) === false) {
            $dt_rescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        } else {
            $dt_rescisao = null;
        }

        $this->_atribuiInicioPeriodo13Salario($dt_admissao);

        $this->_verificaDecimoTerceiroCalculoProvisao($dt_rescisao);

        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );

        $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(
            array('nrorg' => $vinculo->getNrorg(), 'nrestruturam' => $vinculo->historico->getNrestrutsind()));
            
        if(is_object($fpaparamsindicato)) {
            $diasminimo = $fpaparamsindicato->getNrdiv13antecip();
        } else {
            $diasminimo = 15;
        }
        
        $this->_nr_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
        );
        
        if ($this->_nr_doze_avos > 0) {
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_RESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);

            $this->_inicio_periodo_13sal = DateUtil::setDay($this->_inicio_periodo_13sal, 1);
            
            if( $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL

            ){
                $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                $divisorFixoProv = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'VR_DIV_FIXO_PROVISAO');
                
                if($divisorFixoProv){
                    $this->_divisor_13 = $divisorFixoProv;

                    if(((int)$this->_mes_competencia->format('m') == 11 || (int)$this->_mes_competencia->format('m') == 12)){
                        $this->_inicio_periodo_13sal = $this->_mes_competencia;
                    }
                }
                
                $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                    $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $this->_inicio_periodo_13sal,
                    $this->_fim_periodo_13sal , 1,null
                );

                $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                
                $this->_media->geraEventoMedia(
                    $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                    true, $this->_divisor_13
                );
            }
        }
    }
    
    private function _analisa13Sal($vinculo,  $itens_calculo){
       
        $this->_verificaDecimoTerceiro($vinculo, $itens_calculo);
        
        if ($this->_nr_doze_avos > 0) {
            $this->_inicio_periodo_13sal = DateUtil::setDay($this->_inicio_periodo_13sal, 1);
            $fimperiodo13saladiant = $this->_mes_competencia;
			if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) {
				$fimperiodo13saladiant = DateUtil::getUltimoDiaDoMes($fimperiodo13saladiant);
			} else {
				$fimperiodo13saladiant = DateUtil::subtraiIntervalo($fimperiodo13saladiant, 1);
			}
            $eventoAdiantamento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_LIQUIDO, $this->_eventom, $this->_nrorg
            );
            
            $inicio_periodo = $this->_inicio_periodo_13sal;
            $fim_periodo = $fimperiodo13saladiant;
            
            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
            
            if($idMediaUltMes == 1) {
                $nrSindicato = $vinculo->historico->getNrestrutsind();
                if ($nrSindicato) {
                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                        $fim_periodo = $this->_mes_competencia;
                        
                        if($this->_iddesccompetenc == 'S'){
                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                        }else{
                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                        }
                        
                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                        
                        $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno($this->_mes_competencia);
                        $inicio_periodo = $inicio_periodo < $primeiroDiaAno ? $primeiroDiaAno : $inicio_periodo;
                    }
                }
            }
            
            $listaEventosTotalizados = $this->_media->calcula(
                $vinculo, FpatipomovimentEntity::TP_MOV_13SAL, $eventoAdiantamento->getNreventom(), $inicio_periodo,
                $fim_periodo, $this->_nrTipoModalidadeCalc, 1
            );
            $eventoAdiantamentoDb=$this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL_DB, $this->_eventom, $this->_nrorg
            );

            $listaEventosOrigemDestino = array_combine(array($eventoAdiantamento->getNreventom()),array($eventoAdiantamentoDb->getNreventom()));

            $this->_media->geraEventoMedia(
                $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                False, 1
            );
            
            if($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL
                ||$this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR
                ||$this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL
                ||($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_ADIANT_13SAL
                    && $this->_id_media_1p13==FpaParamfolhahEntity::IDMEDIAPRIPARC13_SIM)
                ||($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS
                    && $this->_id_media_1p13==FpaParamfolhahEntity::IDMEDIAPRIPARC13_SIM)
            ){
                $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                if (((int)$this->_fim_periodo_13sal->format('m') == 12) and ($this->_nrOcorrenciaCalc > 1)) {
                    $dataAuxiliar = $this->_fim_periodo_13sal;
                } elseif(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                        ||$this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL
                        ||$this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) && $this->_iddesccompetenc == 'S') {
                    $dataAuxiliar = DateUtil::subtraiIntervalo($this->_fim_periodo_13sal, 1, DateUtil::MES);
                } elseif($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_ADIANT_13SAL && $this->_iddesccompetenc == 'S'){
                    $dataAuxiliar = DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
                }else {
                    $dataAuxiliar = $this->_fim_periodo_13sal;
                }
                
                $inicio_periodo = $this->_inicio_periodo_13sal;
                
                $fim_periodo = $dataAuxiliar;
                $divisorParamSindicato = null;
                
                $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                
                if($idMediaUltMes == 1) {
                    $nrSindicato = $vinculo->historico->getNrestrutsind();
                    if ($nrSindicato) {
                        $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                        if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                            $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                            $fim_periodo = $this->_mes_competencia;
                            
                            if($this->_iddesccompetenc == 'S'){
                                $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                            }else{
                                $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                            }
                        
                            $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                            $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                            
                            $primeiroDiaAno = DateUtil::getPrimeiroDiaDoAno($this->_mes_competencia);
                            $inicio_periodo = $inicio_periodo < $primeiroDiaAno ? $primeiroDiaAno : $inicio_periodo;
                            
                            $divisorParamSindicato = $vrParamSindicato;
                        }
                    }
                }
                
                $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                    $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo,
                    $fim_periodo, 1, null
                );
                $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));

                if($this->_divisor_fixo){
                    $this->_divisor_13 = $this->_divisor_fixo;
                }else if($divisorParamSindicato){
                    $this->_divisor_13 = $divisorParamSindicato;
                }else{
                    $divisor_igual_avo = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_DIV_IGUAL_AVO');
                    
                    if($divisor_igual_avo=='1'){
                        $this->_divisor_13=$this->_nr_doze_avos;
                    }
                }
                
                $this->_media->geraEventoMedia(
                    $itens_calculo, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_13SAL,
                    true, $this->_divisor_13
                );
            }
        }
    }

    private function _analisaFerias($vinculo){

        $this->_verificaFerias($vinculo);
        
        $nr_ferias_preparado = $this->_gozo_ferias->getNrFeriasPreparado();
        
        if ($nr_ferias_preparado) {
            
            $ferias = $this->_ferias->procuraFerias($nr_ferias_preparado);
            $this->verificaDobraFerias($ferias);
            
            $inicio_periodo_aquisitivo = DateUtil::setDay($ferias->getDtiniaquisicao(), 1);
            
            $fim_periodo_aquisitivo = DateUtil::getDataDeString($ferias->getDtfimaquisicao());
            $fim_periodo_aquisitivo_aux = DateUtil::getUltimoDiaDoMes($fim_periodo_aquisitivo);
            
            if ($fim_periodo_aquisitivo_aux->format('d/m/Y') != $fim_periodo_aquisitivo->format('d/m/Y')) {
                $fim_periodo_aquisitivo = DateUtil::getUltimoDiaDoMes(DateUtil::subtraiIntervalo($fim_periodo_aquisitivo, 1, DateUtil::MES)); 
            }
            
            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
            
            $inicio_periodo = $inicio_periodo_aquisitivo;
            $fim_periodo = $fim_periodo_aquisitivo;
            
            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
            
            if($idMediaUltMes == 1) {
                $nrSindicato = $vinculo->historico->getNrestrutsind();
                if ($nrSindicato) {
                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                        $fim_periodo = $this->_mes_competencia;
                        
                        if($this->_iddesccompetenc == 'S'){
                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                        }else{
                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                        }
                        
                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                    }
                }
            }
            
            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo,
                $fim_periodo, 1, null
            );
            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
            
            $this->_media->geraEventoMedia(
                $this->_itens_calculo_principal, $listaEventosTotalizados, $listaEventosOrigemDestino,
                FpatipomovimentEntity::TP_MOV_FERIAS, true, null
            );

        } else {
            $msg = 'Vínculo '.$vinculo->getNrvinculom().' não possui gozo de férias nesta competencia';
            throw new \Exception($msg);
        }
    }

    private function verificaDobraFerias($ferias)
    {
        $dtIniConcessao = DateUtil::adicionaIntervalo($ferias->getDtiniaquisicao(), 1, DateUtil::ANO);
        $dtFimConcessao = DateUtil::adicionaIntervalo($ferias->getDtfimaquisicao(), 1, DateUtil::ANO);
        $dias_dobra = 0;
        
        $diasAfastados = $this->_ferias->_totalizaDiasAfastamentoDobroFerias($this->_alteracao_situacao_funcional, $dtIniConcessao,
        $dtFimConcessao, 180);
        
        if($diasAfastados > 0){
            $dtFimConcessao = DateUtil::adicionaIntervalo($dtFimConcessao, $diasAfastados, DateUtil::DIA);
        }
        
        if($this->_inicio_periodo_saida > $dtFimConcessao){
            $dias_dobra = $this->_diasGozados;
        }elseif($this->_fim_periodo_saida > $dtFimConcessao){
            $dias_dobra = DateUtil::getQtdeDiasEntre($dtFimConcessao, $this->_fim_periodo_saida) + 1;
        }
        
        if($dias_dobra>0){
            $mes1parte = DateUtil::setDay($this->_inicio_periodo_saida, 1);
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento,$mes1parte, 0, $dias_dobra, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS_DOBRA, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes1parte, 0, $dias_dobra, 1);
        }

    }

    private function verificaDobraFeriasRescisaoProvisao($vinculo, $ferias,$diasJaGozados,$contadorFeriasVencidas)
    {
        $dtIniAquisicao = DateUtil::setDay($ferias['DTINIAQUISICAO'], 1);
        $dtLimConcessao = DateUtil::subtraiIntervalo(DateUtil::adicionaIntervalo(substr($ferias['DTFIMAQUISICAO'], 0, 10), 1, DateUtil::ANO), 30);
        
        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $dtRescisao = $dtLimConcessao;
        } else {
            $dtRescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        }

        $dias_dobra=0;
        
        $dtIniConcessao = DateUtil::adicionaIntervalo($ferias['DTINIAQUISICAO'], 1, DateUtil::ANO);
        $dtFimConcessao = DateUtil::adicionaIntervalo($ferias['DTFIMAQUISICAO'], 1, DateUtil::ANO);
        
        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
           $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        
        $diasAfastados = $this->_ferias->_totalizaDiasAfastamentoDobroFerias($this->_alteracao_situacao_funcional, $dtIniConcessao,
        $dtFimConcessao, 180);
        
        if($diasAfastados > 0){
            $dtLimConcessao = DateUtil::adicionaIntervalo($dtLimConcessao, $diasAfastados, DateUtil::DIA);
        }
        
        if($dtRescisao > $dtLimConcessao){
            $dias_dobra = $ferias['QTDIASMAXFE']-$diasJaGozados;
        }
        
        if($dias_dobra>0){
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FER_VENC_RESC_DOBRO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_ferias_vencidas[$contadorFeriasVencidas]->geraEvento($evento,$dtIniAquisicao, 0, $dias_dobra, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_AD_FER_VENC_RESC_DOBRO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_ferias_vencidas[$contadorFeriasVencidas]->geraEvento($evento, $dtIniAquisicao, 0, $dias_dobra, 1);
        }

    }

    private function _analisaFeriasRescisaoProvisao($vinculo, $tp_calc_mov){

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $dt_rescisao_projetada = $this->_ultimo_dia_mes;
            $dataRescisaoProjetado = DateUtil::getDataDeString($dt_rescisao_projetada);
            $ferias = $this->_ferias->verificaFeriasProvisao($vinculo, $dataRescisaoProjetado, true, $this->_eventom,
                $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
                $this->_alteracao_situacao_funcional,$this->_mes_competencia,$this->_jornada_semanal);
        } else {
            $dt_rescisao_projetada = $vinculo->getDtrescisaovinc();
            $dataRescisaoProjetado = DateUtil::getDataDeString($dt_rescisao_projetada);
        
            $ferias = $this->_ferias->verificaFeriasRescisao($vinculo, $dataRescisaoProjetado, true, $this->_eventom,
                $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
                $this->_alteracao_situacao_funcional,$this->_mes_competencia,$this->_jornada_semanal,$this->_nr_tipo_calculo);
        }
        
        if(($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso)>0){
            $dt_rescaux= DateUtil::getDataDeString($dt_rescisao_projetada);
            $ultimo_dia = $this->_ultimo_dia_mes;
            $ultimo_dia_int = $ultimo_dia->format('d');
            if($ultimo_dia_int==31){
                if ($this->_nr_dias_aviso > 0) {
                    $dt_rescaux = DateUtil::adicionaIntervalo($dt_rescaux, $this->_nr_compl_dias_aviso + 31);
                } else {
                    $dt_rescaux = DateUtil::adicionaIntervalo($dt_rescaux, $this->_nr_compl_dias_aviso + $this->_nr_dias_aviso);
                }
            }else{
                $dt_rescaux = DateUtil::adicionaIntervalo($dt_rescaux, $this->_nr_compl_dias_aviso + $this->_nr_dias_aviso);
            }
            $ferias_projetado = $this->_ferias->verificaFeriasRescisao($vinculo, $dt_rescaux, false, $this->_eventom,
                $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
                $this->_alteracao_situacao_funcional,$this->_mes_competencia,$this->_jornada_semanal,$this->_nr_tipo_calculo);
        }
        
        $contador_ferias_vencidas = 0;

        for ($i=0; $i < count($ferias); $i++) {
            
            $dtInicioAquisicao = DateUtil::getDataDeString($ferias[$i]['DTINIAQUISICAO']);
            $dtFimAquisicao = DateUtil::getDataDeString($ferias[$i]['DTFIMAQUISICAO']);
            $multperda=FpatipoferiasmEntity::retornaDiasDireito($ferias[$i]['TIPOFERIAS']);
            $proporcaoPerda=1/($multperda*12)*$ferias[$i]['QTDIASMAXFE'];
            
            switch ($ferias[$i]['IDCONTROLFERIAS']){
                case FpaferiasEntity::IDCONTROLFERIAS_ABERTO:

                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                    );
                    
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE'], 1
                    );
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg
                    );
                    
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                    );
                    
                    $dt_resc = $vinculo->getDtrescisaovinc();
                    if (!(empty($dt_resc))) {
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_DIA, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, ((($ferias[$i]['QTMESESMAXFE']*$proporcaoPerda*2.5))), 1
                        );
                    }
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg
                    );
                    $this->_itens_ferias_proporcionais->geraEvento(
                        $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                    );
                    if(($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso)>0){

                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, $this->_eventom, $this->_nrorg
                        );
                        
                        $referencia = ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE']) > 0 ? ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE']) : 0;
                        
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $referencia, 1
                        );
                        if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $this->_eventom, $this->_nrorg
                            );
                            
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $referencia * $proporcaoPerda, 1
                            );
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $this->_eventom, $this->_nrorg
                            );
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $referencia * $proporcaoPerda, 1
                            );
                        }
                    }
                    $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                    
                    $dtInicioAquisicao = DateUtil::setDay($dtInicioAquisicao, 1);
                    if(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                            || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) && $this->_iddesccompetenc == 'S') {
                        $dtFimAquisicao = DateUtil::subtraiIntervalo($dtFimAquisicao, 1, DateUtil::MES);
                    } 
                    
                    $inicio_periodo = $dtInicioAquisicao;
                    $fim_periodo = $dtFimAquisicao;
                    
                    $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                    
                    if($idMediaUltMes == 1) {
                        $nrSindicato = $vinculo->historico->getNrestrutsind();
                        if ($nrSindicato) {
                            $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                            if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                $fim_periodo = $this->_mes_competencia;
                                
                                if($this->_iddesccompetenc == 'S'){
                                    $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                }else{
                                    $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                }
                        
                                $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                            }
                        }
                    }
                    
                    $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                        $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                        1, null
                    );
                    $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                    
                    $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                    
                    if($this->_divisor_fixo!=false ){
                        $this->_divisor_ferias = $this->_divisor_fixo;
                    }
                    
                    $this->_media->geraEventoMedia(
                        $this->_itens_ferias_proporcionais, $listaEventosTotalizados, $listaEventosOrigemDestino,
                        FpatipomovimentEntity::TP_MOV_FERIAS, true, $this->_divisor_ferias
                    );

                    break;
                    
                case FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO:
                case FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL:
                    
                    if ($contador_ferias_vencidas > count($this->_itens_ferias_vencidas)-1) {
                        $tp_calc_mov->insereNrCalculoFolha(
                            $this->_calculo_folha, $this->_nrorg, $this->_mes_competencia, $this->_ferias_vencidas,
                            $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
                        );

                        $obj = $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas);
                        $obj = end($obj);
                        
                        $instancia = $obj->getInstancia();
                        $instancia->setNrvinculom($this->nrVinculom);
                        
                        $this->_itens_ferias_vencidas[] =  $instancia;
                    }
                    $diasGozados = $ferias[$i]['QTDDIASGOZADOS'];
                    $dt_resc = $vinculo->getDtrescisaovinc();
                    if (!(empty($dt_resc))) {
                       
                        $dt_resc = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
                        $dtIni = DateUtil::getDataDeString($ferias[$i]['DTINIAQUISICAO']);
                        $dtFim = DateUtil::getDataDeString($ferias[$i]['DTFIMAQUISICAO']);
                        
                        if ((($dt_resc->format('d/m/Y') === $dtIni->format('d/m/Y')) || $dt_resc > $dtIni) 
                        && ($dt_resc->format('d/m/Y') === $dtFim->format('d/m/Y') || $dt_resc < $dtFim)) {
                             
                            $mult = 0;
                            $mult=FpatipoferiasmEntity::retornaDiasDireito($ferias[$i]['TIPOFERIAS']);

                            $qtd_doze_avos=0;
                            $data_ini_per= DateUtil::getDataDeString($ferias[$i]['DTINIAQUISICAO']);
                            $data_fim_per_aux = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
                            
                            $qtd_doze_avos = DateUtil::getQtdeMesesEntre($data_ini_per, $data_fim_per_aux);
                            
                            $data_fim_per = DateUtil::adicionaIntervalo($data_ini_per, $qtd_doze_avos, DateUtil::MES);
                            if (($data_fim_per->format('d/m/Y') == $data_fim_per_aux->format('d/m/Y'))
                                ||($data_fim_per < $data_fim_per_aux)
                            ) {
                                $dias = DateUtil::getQtdeDiasEntre($data_fim_per, $data_fim_per_aux) + 1;
                                
                                if ($dias >= 15) {
                                    $qtd_doze_avos++;
                                }
                            }
                            
                            $diasDireito=($qtd_doze_avos*$mult);
                            
                            $ferias[$i]['QTDIASMAXFE'] = $diasDireito>$diasGozados?$diasDireito:$diasGozados;
                                
                            //$ferias[$i]['QTMESESMAXFE'] = $qtd_doze_avos;
                            
                            $avosGozados=floor($diasGozados/$mult);
                            
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                            );
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']-$avosGozados, 1
                            );
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg
                            );
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']-$avosGozados, 1
                            );
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_DIA, $this->_eventom, $this->_nrorg
                            );
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, ((($qtd_doze_avos*2.5)-$diasGozados)), 1
                            );
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg
                            );
                            $this->_itens_ferias_proporcionais->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']-$avosGozados, 1
                            );
                            if(($this->_nr_dias_aviso)>0){

                                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, $this->_eventom, $this->_nrorg
                                );
                                
                                $referencia = ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE']) > 0 ? ($ferias_projetado[$i]['QTMESESMAXFE'] - $ferias[$i]['QTMESESMAXFE']) : 0;
                        
                                $this->_itens_ferias_proporcionais->geraEvento(
                                    $evento, $dtInicioAquisicao, 0, $referencia, 1
                                );

                                if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                        FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $this->_eventom, $this->_nrorg
                                    );
                                    
                                    $this->_itens_ferias_proporcionais->geraEvento(
                                        $evento, $dtInicioAquisicao, 0, $referencia, 1
                                    );
                                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $this->_eventom, $this->_nrorg
                                    );
                                    $this->_itens_ferias_proporcionais->geraEvento(
                                        $evento, $dtInicioAquisicao, 0, $referencia, 1
                                    );
                                }
                            }
                            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();

                            $dtInicioAquisicao = DateUtil::adicionaIntervalo($dtInicioAquisicao, 1); 

                            if(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                                    || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) && $this->_iddesccompetenc == 'S') {
                                $dataAuxiliar = DateUtil::subtraiIntervalo(substr($dtFimAquisicao, 0, 10), 1, DateUtil::MES);
                            } else {
                                $dataAuxiliar = $dtFimAquisicao;
                            }
                            
                            $inicio_periodo = $dtInicioAquisicao;
                            $fim_periodo = $dataAuxiliar;
                            
                            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                            
                            if($idMediaUltMes == 1) {
                                $nrSindicato = $vinculo->historico->getNrestrutsind();
                                if ($nrSindicato) {
                                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                        $fim_periodo = $this->_mes_competencia;
                                        
                                        if($this->_iddesccompetenc == 'S'){
                                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                        }else{
                                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                        }
                        
                                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                                    }
                                }
                            }
                    
                            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                                1, null
                            );
                        
                            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));

                            $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                            
                            if(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO
                                    || $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)&& $dt_resc < $dtFimAquisicao) {
                                $this->_divisor_ferias =  $this->_calculaDivisorMedias($dtInicioAquisicao,$dt_resc);
                            }
                            
                            if($this->_divisor_fixo!=false ){
                                $this->_divisor_ferias = $this->_divisor_fixo;
                            }
                            
                            $this->_media->geraEventoMedia(
                                $this->_itens_ferias_proporcionais, $listaEventosTotalizados, $listaEventosOrigemDestino,
                                FpatipomovimentEntity::TP_MOV_FERIAS, true, $this->_divisor_ferias
                            );

                        }else{
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $this->_eventom, $this->_nrorg
                            );
                            
                            $avos = $ferias[$i]['QTDIASMAXFE']-$diasGozados > 0 ? $ferias[$i]['QTDIASMAXFE']-$diasGozados : 0;
                            
                            $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $avos, 1
                            );

                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $this->_eventom, $this->_nrorg
                            );

                            
                            $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $avos, 1
                            );
                            
                            $this->verificaDobraFeriasRescisaoProvisao($vinculo,$ferias[$i],$diasGozados,$contador_ferias_vencidas);
                            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                            if($dtInicioAquisicao->format('d') != 1){
                                $dtFimAquisicao = DateUtil::getUltimoDiaDoMes(DateUtil::subtraiIntervalo($dtFimAquisicao, 1, DateUtil::MES));
                            }
                            $dtInicioAquisicao = DateUtil::setDay($dtInicioAquisicao, 1);
                            
                            $inicio_periodo = $dtInicioAquisicao;
                            $fim_periodo = $dtFimAquisicao;
                            
                            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                            
                            if($idMediaUltMes == 1) {
                                $nrSindicato = $vinculo->historico->getNrestrutsind();
                                if ($nrSindicato) {
                                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                        $fim_periodo = $this->_mes_competencia;
                                        
                                        if($this->_iddesccompetenc == 'S'){
                                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                        }else{
                                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                        }
                        
                                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                                    }
                                }
                            }
            
                            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                                1, null
                            );
                            
                            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                            
                            $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                            
                            $this->_media->geraEventoMedia(
                                $this->_itens_ferias_vencidas[$contador_ferias_vencidas], $listaEventosTotalizados,
                                $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_FERIAS, true, $this->_divisor_ferias
                            );
                        }
                    } else{
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $this->_eventom, $this->_nrorg
                        );
                        
                        $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE']-$diasGozados, 1
                        );

                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $this->_eventom, $this->_nrorg
                        );

                        $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE']-$diasGozados, 1
                        );
                        $this->verificaDobraFeriasRescisaoProvisao($vinculo,$ferias[$i],$diasGozados,$contador_ferias_vencidas);
                        $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                        
                        if($dtInicioAquisicao->format('d') != 1){
                            $dtFimAquisicao = DateUtil::getUltimoDiaDoMes(DateUtil::subtraiIntervalo($dtFimAquisicao, 1, DateUtil::MES));
                        }
                        
                        $dtInicioAquisicao = DateUtil::setDay($dtInicioAquisicao, 1);
                        
                        $inicio_periodo = $dtInicioAquisicao;
                        $fim_periodo = $dtFimAquisicao;
                        
                        $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                        
                        if($idMediaUltMes == 1) {
                            $nrSindicato = $vinculo->historico->getNrestrutsind();
                            if ($nrSindicato) {
                                $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                                if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                    $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                    $fim_periodo = $this->_mes_competencia;
                                    
                                    if($this->_iddesccompetenc == 'S'){
                                        $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                    }else{
                                        $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                    }
                                    
                                    $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                    $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                                }
                            }
                        }
                        
                        $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                            $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                            1, null
                        );
                        
                        $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                        
                        $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                        
                        $this->_media->geraEventoMedia(
                            $this->_itens_ferias_vencidas[$contador_ferias_vencidas], $listaEventosTotalizados,
                            $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_FERIAS, true,$this->_divisor_ferias
                        );
                    }

                    $contador_ferias_vencidas++;
                    break;
            }
            
            unset($dtInicioAquisicao);
            unset($dtFimAquisicao);
        }
    }

    private function _analisaFeriasProvisao($vinculo, $tp_calc_mov){

            $dataRescisaoProjetado = DateUtil::getDataDeString($this->_ultimo_dia_mes);
            $ferias = $this->_ferias->verificaFeriasProvisao($vinculo, $dataRescisaoProjetado, true, $this->_eventom,
                $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
                $this->_alteracao_situacao_funcional,$this->_mes_competencia,$this->_jornada_semanal);
            
            $contador_ferias_vencidas = 0;

            for ($i=0; $i < count($ferias); $i++) {

                $dtInicioAquisicao = DateUtil::getDataDeString($ferias[$i]['DTINIAQUISICAO']);
                $dtFimAquisicao = DateUtil::getDataDeString($ferias[$i]['DTFIMAQUISICAO']);
               
                $multperda=FpatipoferiasmEntity::retornaDiasDireito($ferias[$i]['TIPOFERIAS']);
                $proporcaoPerda=1/($multperda*12)*$ferias[$i]['QTDIASMAXFE'];
                
                switch ($ferias[$i]['IDCONTROLFERIAS']){
                    case FpaferiasEntity::IDCONTROLFERIAS_ABERTO:
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE'], 1
                        );

                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                        );
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_ferias_proporcionais->geraEvento(
                            $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTMESESMAXFE']*$proporcaoPerda, 1
                        );

                        $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();

                        $dtInicioAquisicao = DateUtil::setDay($dtInicioAquisicao, 1);
                        $dataAuxiliar = $dtFimAquisicao;
                        
                        $inicio_periodo = $dtInicioAquisicao;
                        $fim_periodo = $dtFimAquisicao;
                        
                        $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                        
                        if($idMediaUltMes == 1) {
                            $nrSindicato = $vinculo->historico->getNrestrutsind();
                            if ($nrSindicato) {
                                $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                                if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                    $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                    $fim_periodo = $this->_mes_competencia;
                                    
                                    if($this->_iddesccompetenc == 'S'){
                                        $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                    }else{
                                        $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                    }
                            
                                    $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                    $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                                }
                            }
                        }
                        
                        $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                            $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                            1, null
                        );

                        $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));

                        $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);

                        if($this->_divisor_fixo != false ){
                            $this->_divisor_ferias = $this->_divisor_fixo;
                        }
                        
                        $this->_media->geraEventoMedia(
                            $this->_itens_ferias_proporcionais, $listaEventosTotalizados, $listaEventosOrigemDestino,
                            FpatipomovimentEntity::TP_MOV_FERIAS, true, $this->_divisor_ferias
                        );

                        break;

                    case FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO:
                    case FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL:
                            
                                    
                        if ($contador_ferias_vencidas > count($this->_itens_ferias_vencidas)-1) {
                            
                            $tp_calc_mov->insereNrCalculoFolha(
                                $this->_calculo_folha, $this->_nrorg, $this->_mes_competencia, $this->_ferias_vencidas,
                                $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc
                            );

                            $obj = $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas);
                            $obj = end($obj);
                            
                            $instancia = $obj->getInstancia();
                            $instancia->setNrvinculom($this->nrVinculom);
                            
                            $this->_itens_ferias_vencidas[] =  $instancia;
                        }
                        
                        $diasGozados = $ferias[$i]['QTDDIASGOZADOS'];

                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $this->_eventom, $this->_nrorg
                            );

                            $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE']-$diasGozados, 1
                            );

                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $this->_eventom, $this->_nrorg
                            );

                            $this->_itens_ferias_vencidas[$contador_ferias_vencidas]->geraEvento(
                                $evento, $dtInicioAquisicao, 0, $ferias[$i]['QTDIASMAXFE']-$diasGozados, 1
                            );
                            
                            $this->verificaDobraFeriasRescisaoProvisao($vinculo,$ferias[$i],$diasGozados,$contador_ferias_vencidas);
                            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
                            if($dtInicioAquisicao->format('d') != 1){
                                $dtFimAquisicao = DateUtil::getUltimoDiaDoMes(DateUtil::subtraiIntervalo($dtFimAquisicao, 1, DateUtil::MES));
                            }
                            $dtInicioAquisicao = DateUtil::setDay($dtInicioAquisicao, 1);
                            
                            $inicio_periodo = $dtInicioAquisicao;
                            $fim_periodo = $dtFimAquisicao;
                            
                            $idMediaUltMes = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_MEDIA_ULT_MES');
                            
                            if($idMediaUltMes == 1) {
                                $nrSindicato = $vinculo->historico->getNrestrutsind();
                                if ($nrSindicato) {
                                    $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(array('nrestruturam' => $nrSindicato, 'nrorg' => $vinculo->getNrorg()));
                                    if ($fpaparamsindicato && $fpaparamsindicato->getNrmesesmedia1() < 12) {
                                        $vrParamSindicato = $fpaparamsindicato->getNrmesesmedia1();
                                        $fim_periodo = $this->_mes_competencia;
                                        
                                        if($this->_iddesccompetenc == 'S'){
                                            $fim_periodo = DateUtil::subtraiIntervalo($fim_periodo, 1);
                                        }else{
                                            $fim_periodo = DateUtil::getUltimoDiaDoMes($fim_periodo);
                                        }
                                
                                        $inicio_periodo = DateUtil::subtraiIntervalo($fim_periodo, $vrParamSindicato - 1, DateUtil::MES);
                                        $inicio_periodo = DateUtil::setDay($inicio_periodo, 1);
                                    }
                                }
                            }
                            
                            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
                                $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicio_periodo, $fim_periodo,
                                1, null
                            );
                            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                            
                            $this->_divisor_ferias =  $this->_calculaDivisorMedias($inicio_periodo, $fim_periodo);
                            
                            $this->_media->geraEventoMedia(
                                $this->_itens_ferias_vencidas[$contador_ferias_vencidas], $listaEventosTotalizados,
                                $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_FERIAS, true,$this->_divisor_ferias
                            );

                        $contador_ferias_vencidas++;
                        break;
                }

                unset($dtInicioAquisicao);
                unset($dtFimAquisicao);
            }
            
    }
    
    private function _analisaFimContrato($vinculo, $itens_calculo){
        $auxGeraEvento=false;

        $diasExp1 = $vinculo->getNrdiascontratoexp() ? $vinculo->getNrdiascontratoexp()-1 : 0;
        $diasExp2 = $vinculo->getNrdiascontratoexppro() ? $vinculo->getNrdiascontratoexppro() : 0;

        $this->_dt_fim_exp1 = DateUtil::adicionaIntervalo($vinculo->getDtadmissaovinc(), $diasExp1);
        $this->_dt_fim_exp2 = DateUtil::adicionaIntervalo($vinculo->getDtadmissaovinc(), $diasExp1+$diasExp2);
        
        if($this->_nr_tipo_calculo==FpaTipocalculoEntity::CALC_PROVISAO_CONTABIL){
            $dtRescisao = DateUtil::getDataDeString(FPA::getUltimoDiaMes());
        }
        else{
            $dtRescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        }

        if($vinculo->getNrdiascontratoexp()!=null && $dtRescisao < $this->_dt_fim_exp1){
            $diasInden = ((DateUtil::getQtdeDiasEntre($dtRescisao, $this->_dt_fim_exp1)) / 2);
            $auxGeraEvento=true;
        }elseif($vinculo->getNrdiascontratoexppro()!=null && $dtRescisao < $this->_dt_fim_exp2){
            $diasInden = ((DateUtil::getQtdeDiasEntre($dtRescisao, $this->_dt_fim_exp2)) / 2);
            $auxGeraEvento=true;
        }elseif($vinculo->historico->getDtfimcontrdetermin()!= null && $dtRescisao < DateUtil::getDataDeString($vinculo->historico->getDtfimcontrdetermin())){
            $diasInden = ((DateUtil::getQtdeDiasEntre($dtRescisao, $vinculo->historico->getDtfimcontrdetermin())) / 2);
            $auxGeraEvento=true;
        }else{
            if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::SEM_JUSTA_CAUSA_EMPREGADO){
                if($vinculo->getDtrescisaovinc() == $vinculo->getDtavisoprevio()) {
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_DESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, 30, 1);
                }
            }else{
                $this->_analisaAvisoPrevio($vinculo, $this->_itens_aviso_previo);
                $this->_indenizaPeriodoDissidio($vinculo,$this->_itens_calculo_principal);

            }
        }
        if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ANTECIPACAO_EMPREGADO && $auxGeraEvento==true){
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INDENIZ_ART_480, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->geraEvento($evento, null, 0,  $diasInden, 1);
        }
        if ($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::ANTECIPACAO_EMPREGADOR && $auxGeraEvento==true){
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INDENIZ_ART_479, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->geraEvento($evento, null, 0,  $diasInden, 1);
        }
    }

    private function _quantidadeDiasAfastados($dt_inicio, $dt_fim){

        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento(
            $this->_situacao_funcional, $dt_inicio, $dt_fim, false
        );

        $dias_afastados = 0;
        for ($i=0; $i < count($afastamento); $i++) {
            $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                $this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]
            );
            
            if ($sit_func == true) {
                if ($sit_func->historico->getIdsusp13sal() === GpesitufunchEntity::IDSUSP13SAL_SIM) {
                    $dias_afastados++;
                }
            }
        }

        return $dias_afastados;
    }

    private function _temAtivNormalNoMes($vinculo, $dt_inicio, $dt_fim, $qtMinimoDias){
        $temAtivNormal = false;
        $qtdDiasNormal = 0;

        $arrayAtivNormal = $this->_alteracao_situacao_funcional->retornaSituacaoFuncionalNrsituDentroPeriodoExclusivo($this->_nrorg, $vinculo->getNrvinculom(), $dt_inicio, $dt_fim, GpealtesitufuncEntity::SIT_FUNC_NORMAL);

        if($arrayAtivNormal) {
            foreach($arrayAtivNormal as $ativNormal) {
                if($ativNormal->getNrqtdiasitufunc()) {
                    $qtdDiasNormal += $ativNormal->getNrqtdiasitufunc();
                }
                else if($ativNormal->getDtfimsitufunc()) {
                    $comparacaoQtde = DateUtil::getQtdeDiasEntre($ativNormal->getDtinisitufunc(), $ativNormal->getDtfimsitufunc()) + 1;
                    $qtdDiasNormal += $comparacaoQtde;
                }
                else {
                    $dtiniposicao = $ativNormal->getDtinisitufunc();
                    $dtfimposicao = DateUtil::getUltimoDiaDoMes($dtiniposicao);
                    $comparacaoQtde = DateUtil::getQtdeDiasEntre($dtiniposicao, $dtfimposicao) + 1;
                    $qtdDiasNormal += $comparacaoQtde;
                }
                if($qtdDiasNormal >= $qtMinimoDias){
                    $temAtivNormal = true;
                    break;
                }
                $comparacaoQtde = $dtiniposicao = $dtfimposicao = null;
            }
        }
        return $temAtivNormal;
    }

    private function _quantidadeMesesAfastPorSituFunc(GpevinculomEntity $vinculo,$situ_func,$dias_minimo){

        $alte_situ_func = new GpealtesitufuncEntity();
        $obj_alte_situ_func = current($alte_situ_func->retornaAlteSitFuncporVinculoNrsituacao($vinculo->getNrvinculom(),$situ_func,$this->_nrorg));

        if (!is_object($obj_alte_situ_func)){
            $mesesAfastados=0;
        }else {
            $inicioperiodo = new TkDateTime($obj_alte_situ_func->getDtinisitufunc());
            $fimperiodo = new TkDateTime($obj_alte_situ_func->getDtfimsitufunc());

            if($fimperiodo->isEarlier($this->_primeiro_dia_ano) || $inicioperiodo->isLater($this->_ultimo_dia_ano)){
                $mesesAfastados=0;
            }else{
                if ($inicioperiodo->isEarlier($this->_primeiro_dia_ano) === true) {
                    $inicioperiodo = $this->_primeiro_dia_ano;
                }
                if ($fimperiodo->isLater($this->_ultimo_dia_ano) === true) {
                    $fimperiodo = $this->_ultimo_dia_ano;
                }
                $mesesAfastados=$this->_calculaNrDozeAvosDecimoTerceiro($vinculo,$inicioperiodo,$fimperiodo,$dias_minimo);
            }
        }
        return $mesesAfastados;
    }

    private function _quantidadediasAfastPorSituFunc($situ_func){

        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento(
            $this->_situacao_funcional, $this->_primeiro_dia_ano, $this->_ultimo_dia_ano, false
        );

        $dias_afastados = 0;
        for ($i=0; $i < count($afastamento); $i++) {
            $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                $this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]
            );

            if ($sit_func == true) {
                if ($sit_func->getNrsitufuncm() == $situ_func) {
                    $dias_afastados++;
                }
            }
        }
        return $dias_afastados;

    }

    private function _quantidadeFaltas($vinculo, $dt_inicio, $dt_fim){

        $lista_eventos = $this->_faltas_intervalo->calcula(
            $vinculo, $dt_inicio, $dt_fim, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc, $this->_nrOrgPadrao
        );

        $total_dias = 0;

        foreach ($lista_eventos as $nr_evento=> $item_evento) {
            $evento = $this->_eventom->retornaEvento($nr_evento);
            $tipo_referencia = $evento->historico->getIdunidrefereven();
            $id_faltas_ferias = $evento->historico->getIdfaltasferias();

            $total_aux = number_format(
                FpaeventomEntity::compatibilizaReferenciaDias($item_evento['REF'], $tipo_referencia, $this->_jornada_diaria), 2
            );

            switch ($id_faltas_ferias){
                case FpaeventohEntity::IDFALTASFERIAS_SOMA:		$total_dias += $total_aux; break;
                case FpaeventohEntity::IDFALTASFERIAS_SUBTRAI: 	$total_dias -= $total_aux; break;
            }
        }

        return  floor($total_dias);

    }
    
    private function _calculaNrDozeAvosDecimoTerceiro($vinculo, $dt_inicio, $dt_fim, $qtMinimoDias=15){
        
        $dt_inicio = DateUtil::getDataDeString($dt_inicio);
        $dt_fim = DateUtil::getDataDeString($dt_fim);

        $mes_ini = $dt_inicio->format('m');
        $mes_fim = $dt_fim->format('m');
        $nr_doze_avos = 0;
        $dt_aux_inicio = $dt_inicio;
        
        $ano_ini=$dt_inicio->format('Y');
        $ano_fim=$dt_fim->format('Y');
        if($ano_fim>$ano_ini){
            $mes_fim=13;
        }
        
        for ($i = $mes_ini; $i<=($mes_fim); $i++) {
            if ($i == $mes_ini) {
                $dt_aux_inicio = $dt_inicio;
                $dt_aux_fim = DateUtil::getUltimoDiaDoMes($dt_inicio);
                
                if($dt_aux_fim > $dt_fim){                          
                    $dt_aux_fim = $dt_fim;      
                }
            } 
            elseif ($i == $mes_fim) {
                $dt_aux_inicio = DateUtil::setDay($dt_fim, 1);
                $dt_aux_fim = $dt_fim;
            } else {
                $dt_aux_inicio =  DateUtil::setDay(DateUtil::setMonth($dt_inicio, $i), 1);
                $dt_aux_fim = DateUtil::getUltimoDiaDoMes($dt_aux_inicio);
            }
            
            $considera30dias = $this->_valores_referencia->getValorReferencia("DECIMOCONSIDERA30DIAS");
            if($considera30dias && $dt_aux_fim->format('d') == '31'){
                $dt_aux_fim = '30/'.$dt_aux_fim->format('m/Y');
                $dt_aux_fim = DateUtil::getDataDeString($dt_aux_fim);
                $qtMinimoDias = 15;
            }
            
            $dias_intervalo = DateUtil::getQtdeDiasEntre($dt_aux_inicio, $dt_aux_fim) + 1;
            
            if ($dias_intervalo >= $qtMinimoDias) {
                $dias_afastados = $this->_quantidadeDiasAfastados($dt_aux_inicio, $dt_aux_fim);
                $dias_faltas=$this->_quantidadeFaltas($vinculo, $dt_aux_inicio, $dt_aux_fim);
            
                if (($dias_intervalo - $dias_afastados - $dias_faltas) >= $qtMinimoDias) {
                    $nr_doze_avos++;
                }
            }
        }
        return $nr_doze_avos;

    }

    private function _calculaNrDozeAvosDecimoTerceiro13Afast($vinculo, $arrayAlteSituFunc13Afast, $qtMinimoDias=15){
        $nr_doze_avos = 0;
        $dias_intervalo_anterior = 0;
        $guardaDiasIntervalo = false;
        
        foreach($arrayAlteSituFunc13Afast as $alteSituFunc) {
            $dt_inicio = DateUtil::comparaDatas($alteSituFunc->getDtinisitufunc(), $this->_inicio_periodo_13sal) ? $this->_inicio_periodo_13sal : $alteSituFunc->getDtinisitufunc();
            $dt_fim = $alteSituFunc->getDtfimsitufunc() ? $alteSituFunc->getDtfimsitufunc() : ($vinculo->getDtrescisaovinc() ? $vinculo->getDtrescisaovinc() : $this->_fim_periodo_13sal);
            $diasIguais = DateUtil::comparaDatas($dt_inicio, $dt_fim, DateUtil::IGUAL);

            if($diasIguais)
                $guardaDiasIntervalo = true;
            
            $mes_ini = $dt_inicio->format('m');
            $mes_fim = $dt_fim->format('m');
            $dt_aux_inicio = $dt_inicio;
            
            $ano_ini=$dt_inicio->format('Y');
            $ano_fim=$dt_fim->format('Y');

            if($ano_fim>$ano_ini){
                $mes_fim=13;
            }

            for ($i = $mes_ini; $i<=($mes_fim); $i++) {
                if ($i == $mes_ini) {
                    $dt_aux_inicio = $dt_inicio;
                    $dt_aux_fim = DateUtil::getUltimoDiaDoMes($dt_inicio);
                    
                    if($dt_aux_fim > $dt_fim){
                        $dt_aux_fim = $dt_fim;
                    }
                }
                else if ($i == $mes_fim) {
                    $dt_aux_inicio = DateUtil::setDay($dt_fim, 1);
                    $dt_aux_fim = $dt_fim;
                } else {
                    $dt_aux_inicio =  DateUtil::setDay(DateUtil::setMonth($dt_inicio, $i), 1);
                    $dt_aux_fim = DateUtil::getUltimoDiaDoMes($dt_aux_inicio);
                }
                
                $dias_intervalo = DateUtil::getQtdeDiasEntre($dt_aux_inicio, $dt_aux_fim) + 1;
                $dt_aux_inicio = DateUtil::getPrimeiroDiaDoMes($dt_aux_inicio);
                $dt_aux_fim = DateUtil::getUltimoDiaDoMes($dt_aux_fim);
                $ativNormal = $this->_temAtivNormalNoMes($vinculo, $dt_aux_inicio, $dt_aux_fim, $qtMinimoDias);

                if($dias_intervalo_anterior) {
                    $dias_intervalo += $dias_intervalo_anterior;
                    $dias_intervalo_anterior = 0;
                    $guardaDiasIntervalo = false;
                }
                else if($guardaDiasIntervalo) {
                    $dias_intervalo_anterior += $dias_intervalo;
                }

                if ($dias_intervalo >= $qtMinimoDias && !$ativNormal) {
                    $nr_doze_avos++;
                }
            }
            $dt_inicio = $dt_fim = $mes_ini = $mes_fim = $dt_aux_inicio = $ano_ini = $ano_fim = $dt_aux_fim = $dias_intervalo = null;
        }
        return $nr_doze_avos;
    }

    private function _calculaDivisorMedias($dt_inicio,$dt_fim){

        $data1 = $dt_inicio;
        $arr = explode('/',$data1);

        $data2 = $dt_fim;
        $arr2 = explode('/',$data2);

        $mes1 = $arr[1];
        $ano1 = $arr[2];

        $mes2 = $arr2[1];
        $ano2 = $arr2[2];

        $a1 = ($ano2 - $ano1)*12;
        $m1 = ($mes2 - $mes1)+1;
        $divisor = ($m1 + $a1);

        if ($divisor>12){
            $divisor=12;
        }

        return $divisor;

    }

    private function _atribuiInicioPeriodoAvisoPrevio($dtAdmissao){
        if ($dtAdmissao > $this->_12_meses_atras) {
            $this->_inicio_periodo_aviso = $dtAdmissao;
        } else {
            $this->_inicio_periodo_aviso = $this->_12_meses_atras;
        }
    }
    
    private function _atribuiInicioPeriodo13Salario($dtAdmissao){
        if ($dtAdmissao > $this->_primeiro_dia_ano) {
            $this->_inicio_periodo_13sal = $dtAdmissao;
        } else {
            $this->_inicio_periodo_13sal = $this->_primeiro_dia_ano;
        }
    }

    private function _atribuiFimPeriodoAvisoPrevio($dtRescisao){
        if ($dtRescisao !== null) {
            if ($dtRescisao < $this->_ultimo_dia_ano) {
                $this->_fim_periodo_aviso = $dtRescisao;
            } else {
                $this->_fim_periodo_aviso = $this->_ultimo_dia_ano;
            }
        } else {
            $this->_fim_periodo_aviso = $this->_ultimo_dia_ano;
        }
    }

    private function _atribuiFimPeriodo13Salario($dtRescisao){
        if ($dtRescisao !== null) {
            if ($dtRescisao < $this->_ultimo_dia_ano) {
                $this->_fim_periodo_13sal = $dtRescisao;
            } else {
                $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
            }
        } else {
            $this->_fim_periodo_13sal = $this->_ultimo_dia_ano;
        }
    }
    
    private function _verificaAvisoPrevio($vinculo, $itens_calculo){
        $dt_admissao = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());

        $dt_rescisao = $vinculo->getDtrescisaovinc();
        if (empty($dt_rescisao) === false) {
            $dt_rescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        } else {
            $dt_rescisao = null;
        }

        $this->_atribuiInicioPeriodoAvisoPrevio($dt_admissao);

        $this->_verificaAvisoPrevioCalculoProvisao($dt_rescisao);
        
        $this->_nr_dias_aviso = 30;
        
        if(!$vinculo->getDtavisoprevio() || ($vinculo->getDtavisoprevio() && $vinculo->getDtrescisaovinc()->format('d/m/Y') != $vinculo->getDtavisoprevio()->format('d/m/Y'))){
            if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                $this->_nr_dias_aviso = 0;
            }
        }

        $dtadmaux = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
        
        if ($vinculo->getDtrescisaovinc() != null){
            $dtrescaux = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
        }else {
            $dtrescaux = DateUtil::getDataDeString($this->_mes_competencia);
        }

        $dtrescaux = DateUtil::adicionaIntervalo($dtrescaux, $this->_nr_dias_aviso);
        
        $intervaloanos = abs(DateUtil::getQtdeAnosEntre($dtrescaux, $dtadmaux));
        
        $anosPerdidos = $this->_alteracao_situacao_funcional->retornaAnosPerdidosAfastamento($vinculo, $dt_admissao, $dt_rescisao);
        
        $intervaloanos = $intervaloanos > $anosPerdidos ? $intervaloanos - $anosPerdidos : 0;
        
        if($intervaloanos>20){
            $intervaloanos=20;
        }
        
        if (empty($dt_rescisao) === false) {
            if(abs(DateUtil::getQtdeAnosEntre($dt_rescisao, $dt_admissao)) >0) {
                $this->_nr_compl_dias_aviso = $intervaloanos * 3;
            } else {
                $this->_nr_compl_dias_aviso=0;
            }
        } else {
            $this->_nr_compl_dias_aviso=0;
        }
        
        if(!$vinculo->getDtavisoprevio() || ($vinculo->getDtavisoprevio() && $vinculo->getDtrescisaovinc()->format('d/m/Y') != $vinculo->getDtavisoprevio()->format('d/m/Y'))){
            if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                $this->_nr_dias_aviso = 0;
            }
        }
        
        if ($this->_nr_dias_aviso > 0 || ($this->_nr_dias_aviso+$this->_nr_compl_dias_aviso > 0 && $this->_indeniza_complemento!=false)) {
            switch($this->_nr_tipo_calculo){

                case FpatipocalculoEntity::CALC_RESCISAO:
                case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
                case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_dias_aviso, 1);
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_compl_dias_aviso, 1);
                    break;
                default:
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Calculo '.$this->_nr_tipo_calculo.' nao tratado.',MsgCalculo::ERRO,true);
                
            }
        }
    }
    
    private function _verificaDecimoTerceiro($vinculo, $itens_calculo){
        $dt_admissao = $vinculo->getDtadmissaovinc();

        $dt_rescisao = $vinculo->getDtrescisaovinc();

        $this->_atribuiInicioPeriodo13Salario($dt_admissao);

        $this->_verificaDecimoTerceiroCalculoProvisao($dt_rescisao);

        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        
        $fpaparamsindicato = \Folha\Entities\FpaParamsindicato::findOneByNrestruturamAndNrorg($vinculo->historico->getNrestrutsind(),$vinculo->getNrorg());
        
        if(is_object($fpaparamsindicato)) {
            $diasminimo = $fpaparamsindicato->getNrdiv13antecip();
        } else {
            $diasminimo = 15;
        }
        $dtfinal = DateUtil::getUltimoDiaDoMes($this->_mes_competencia); 
        
        if(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL && ($this->_iddesccompetenc == 'S') and
                !(((int)$this->_fim_periodo_13sal->format('m') == 12) and ($this->_nrOcorrenciaCalc > 1))) ||
            (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_ADIANT_13SAL)&& ($this->_iddesccompetenc == 'S')))
        {   
            $dtfinal = DateUtil::SubtraiIntervalo($dtfinal, 1, DateUtil::MES);
        }elseif(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO) && ($this->_iddesccompetenc == 'S')){
            $dtfinal = DateUtil::SubtraiIntervalo($dtfinal, 1, DateUtil::MES);
            
        }elseif( $this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR){
            $dtfinal = DateUtil::getUltimoDiaDoMes($vinculo->getDtrescisaovinc());
            if($this->_iddesccompetenc == 'S'){
                $dtfinal = DateUtil::SubtraiIntervalo($dtfinal, 1, DateUtil::MES);
                
            }
        }
        
        $this->_divisor_13 = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $dtfinal, $diasminimo);
         
        $this->_nr_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
        );
        
        $dt_rescaux = DateUtil::adicionaIntervalo($this->_fim_periodo_13sal, $this->_nr_compl_dias_aviso + $this->_nr_dias_aviso);
        
        $this->_nr_compl_doze_avos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
            $this->_inicio_periodo_13sal, $dt_rescaux
        );
        
        $this->_nr_compl_doze_avos = $this->_nr_compl_doze_avos-$this->_nr_doze_avos;
        
        if (($this->_nr_doze_avos + $this->_nr_compl_doze_avos ) > 0) {
            switch($this->_nr_tipo_calculo){
                case FpatipocalculoEntity::CALC_13SAL:
                    $arrayAlteSituFuncAte15D = $this->_alteracao_situacao_funcional->retornaSituacaoFuncionalNrsituDentroPeriodo($this->_nrorg, $vinculo->getNrvinculom(), $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal, GpealtesitufuncEntity::SIT_FUNC_ACIDENTE_15D);

                    if($arrayAlteSituFuncAte15D) {
                        $nrAvos = $this->_calculaNrDozeAvosDecimoTerceiro13Afast($vinculo, $arrayAlteSituFuncAte15D);

                        if($nrAvos > 0)
                            $this->_nr_doze_avos += $nrAvos;
                    }
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13_SAL_MATERNIDADE, $this->_eventom, $this->_nrorg
                    );
                    $nrDias13SalMaternidade=$this->_quantidadediasAfastPorSituFunc(GpealtesitufuncEntity::SIT_FUNC_SAL_MATERNIDADE);
                    $itens_calculo->geraEvento($evento, null, 0, $nrDias13SalMaternidade, 1);
                    
                    $arrayAlteSituFunc13Afast = $this->_alteracao_situacao_funcional->retornaSituacaoFuncionalNrsituDentroPeriodo($this->_nrorg, $vinculo->getNrvinculom(), $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal, GpealtesitufuncEntity::SIT_FUNC_ACIDENTE_SUP_15D);
                    
                    if($arrayAlteSituFunc13Afast){
                        $nrAvos13Afast = $this->_calculaNrDozeAvosDecimoTerceiro13Afast($vinculo, $arrayAlteSituFunc13Afast);
                        
                        if($nrAvos13Afast > 0) {
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_FGTS_13SAL_AFAST, $this->_eventom, $this->_nrorg
                            );
                            $itens_calculo->geraEvento($evento, null, 0, $nrAvos13Afast, 1);
                        }
                    }

                    break;
                case FpatipocalculoEntity::CALC_ADIANT_13SAL:
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_percentual_adiantamento, 1);
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
                    break;
                case FpatipocalculoEntity::CALC_RESCISAO:
                case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR:
                case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL:
                    
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_13SAL_RESC, $this->_eventom, $this->_nrorg
                    );
                    $itens_calculo->geraEvento($evento, null, 0, $this->_nr_doze_avos, 1);
                    
                    if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
                        
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC, $this->_eventom, $this->_nrorg
                        );
                        
                        $itens_calculo->geraEvento($evento, null, 0, $this->_nr_compl_doze_avos, 1);

                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_13_SAL_MATERNIDADE, $this->_eventom, $this->_nrorg
                        );
                        $nrDias13SalMaternidadeResc=$this->_quantidadediasAfastPorSituFunc(GpealtesitufuncEntity::SIT_FUNC_SAL_MATERNIDADE);
                        $itens_calculo->geraEvento($evento, null, 0, $nrDias13SalMaternidadeResc, 1);
                    }
                    break;
                    
                case FpatipocalculoEntity::CALC_FERIAS:
                    if ($this->_inicio_periodo_saida !== null) {
                        
                        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
                        $itemGozo = $this->_gozo_ferias->procuraGozoFerias($this->_inicio_periodo_saida->format('d/m/Y'));
                        
                        if ($itemGozo && ($itemGozo->getIdadiant13salar() == FpagozoferiasEntity::IDADIANT13SALAR_SIM)) {
                            $this->_itens_13sal->getItems();
                            
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                            );
                            $itens_calculo->geraEvento($evento, $this->_inicio_periodo_saida, 0, $this->_percentual_adiantamento, 1);
                            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                                FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $this->_eventom, $this->_nrorg
                            );
                            $itens_calculo->geraEvento($evento, $this->_inicio_periodo_saida, 0, $this->_nr_doze_avos, 1);
                        }
                    }
                    break;
                default:
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Calculo '.$this->_nr_tipo_calculo.' não tratado.',MsgCalculo::ERRO,true);
            }
        }
    }
    
    private function _verificaAvisoPrevioCalculoProvisao($dt_rescisao) {
        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_fim_periodo_aviso = $this->_ultimo_dia_mes;
        } else {
            $this->_atribuiFimPeriodoAvisoPrevio($dt_rescisao);
        }
    }

    private function _verificaDecimoTerceiroCalculoProvisao($dt_rescisao) {
        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_fim_periodo_13sal = $this->_ultimo_dia_mes;
        } else {
            $this->_atribuiFimPeriodo13Salario($dt_rescisao);
        }
    }

    private function _verificaFerias($vinculo){
        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        
        if($this->_inicio_periodo_saida && $this->_fim_periodo_saida && !$this->_gozo_ferias->retornaNrFeriasPeloGozo($this->_inicio_periodo_saida, $this->_fim_periodo_saida)){
            return;
        }
        $nr_ferias_preparado = $this->_gozo_ferias->getNrFeriasPreparado();
        $ferias = $this->_ferias->procuraFerias($nr_ferias_preparado);
        if(!$this->validaGozo($vinculo, $ferias)){
            $this->_gozo_ferias->setNrFeriasPreparado(null);
            return;
        }
        $this->_gozo_ferias->trataGozoFerias($this->_mes_competencia, $ferias, $this->_dtInicio, $this->_dtFim);
        $mes_1a_parte = $this->_gozo_ferias->getMes1aParte();
        $dias_1a_parte = $this->_gozo_ferias->getDias1aParte();
        $mes_2a_parte = $this->_gozo_ferias->getMes2aParte();
        $dias_2a_parte = $this->_gozo_ferias->getDias2aParte();
        $dias_abono = $this->_gozo_ferias->getDiasAbono();
        $this->nrGozoFerias = $this->_gozo_ferias->getNrgozoferiasAtual();
        
        if ($dias_1a_parte > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_1_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INSS_FERIAS, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, 0, 1);

            if ($dias_1a_parte >= $this->_nrDiasFeriasProvisao) {
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PROVIS_FERIAS_DB, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_1a_parte, 1);
            }
            $itemGozo = $this->_gozo_ferias->procuraGozoFerias($this->_inicio_periodo_saida);
            
            if($itemGozo){
                $this->_fim_periodo_saida = $itemGozo->getDtfimgozoferias();
            }
            
            if ($itemGozo && ($itemGozo->getIdadiant13salar() === FpagozoferiasEntity::IDADIANT13SALAR_SIM)) {
                
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                );
                
                //Gerar evento de salario para contemplar o adiantamento nas ferias.
                if(count($this->_itens_13sal->getItems()) < 1){
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
                    );
                    
                    $this->_itens_13sal->geraEvento($evento, $mes_1a_parte, $this->_salario, 30, 1);
                }
                
                $this->_itens_calculo_principal->geraEvento(
                    $evento, $mes_1a_parte, 0, $this->_vrPercentAdiant13Sal, 1
                );

                $dtInicio = DateUtil::getDataDeString($vinculo->getDtadmissaovinc());
                $this->_atribuiInicioPeriodo13Salario($dtInicio);
                if ($vinculo->getDtrescisaovinc() === true) {
                    $dtFim = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
                } else {
                    $dtFim = null;
                }

                $this->_atribuiFimPeriodo13Salario($dtFim);

                $nrDozeAvos = $this->_calculaNrDozeAvosDecimoTerceiro($vinculo,
                    $this->_inicio_periodo_13sal, $this->_fim_periodo_13sal
                );
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $nrDozeAvos, 1);
            }
            
        }

        if ($dias_2a_parte > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_INSS_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, 0, 1);

            if ($dias_2a_parte >= $this->_nrDiasFeriasProvisao) {
                $evento = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PROVIS_2_PARTE_DB, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento, $mes_2a_parte, 0, $dias_2a_parte, 1);
            }
        }

        if ($dias_abono > 0) {
            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ADIC_ABONO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);

            $evento = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_ABONO, $this->_eventom, $this->_nrorg
            );
            $this->_itens_calculo_principal->geraEvento($evento, $mes_1a_parte, 0, $dias_abono, 1);
        }
        return true;
    }
    
    private function validaGozo($vinculo, $ferias) {
        if (empty($ferias)) {
            return false;
        }
        
        $dtiniaquisicao = DateUtil::setDay($ferias->getDtiniaquisicao(), 1);
        $dtfimaquisicao = DateUtil::subtraiIntervalo(DateUtil::setDay($ferias->getDtfimaquisicao(), 1), 1, DateUtil::MES);
        
        $gozoFerias = $this->_ferias->getGozoFerias($ferias->getNrferias());
        $diasFaltas = $this->_ferias->_totalizaDiasFaltas(
            $vinculo, $this->_eventom, $this->_faltas_intervalo, $dtiniaquisicao,
            $dtfimaquisicao, $this->_jornada_diaria, $this->_nrTipoModalidadeCalc,
            $this->_nrOcorrenciaCalc
        );
        $faltaFerias = new FpafaltaferiasEntity($this->entityManager, $this->hcmParameters);
        $faltaFerias = $faltaFerias->verificaFaltaFerias($ferias->getNrtipoferias(), $diasFaltas);
        $tipoFerias = new FpatipoferiasmEntity($this->entityManager, $this->hcmParameters);
        $tipoFerias = $tipoFerias->retornaTipoFerias($this->_nrOrgPadrao, $this->_nrorg, $ferias->getNrtipoferias());
        $mes_afastados = $this->_ferias->_quantidadeMesAfastados($ferias->getDtiniaquisicao(), $ferias->getDtfimaquisicao());
        $dias_afastados = 0;
        
        $minimizaAvos = $this->_valores_referencia->getValorReferencia("VR_MINIMIZA_AVOS");
        
        if($minimizaAvos == 1){
            $dias_afastados = $mes_afastados > 0 ? floor($mes_afastados * 2.5) : 0;
        }
        
        foreach ($gozoFerias as $key => $itemGozo) {
            $diasAbono = $itemGozo->getQtdiasabonoferi()?$itemGozo->getQtdiasabonoferi():0;
            $diasAbono = $diasAbono !== 0 ? $faltaFerias->getQtdiasmaxabon(): 0;
            $dias = $itemGozo->getDiasDataInicioAteDataFim() < $tipoFerias->historico->getQtdiasminfe() ? $tipoFerias->historico->getQtdiasminfe() : $itemGozo->getDiasDataInicioAteDataFim();
            if (is_object($faltaFerias)) {
                if($key == 0) {
                    
                    if ($dias <= $tipoFerias->historico->getQtdiasminfe()) {
                        if (!$this->atualizaGozoInvalido($itemGozo, $dias, $vinculo, $faltaFerias, $diasAbono)) {
                            return false;
                        }
                    }
                    
                    // > DIAS MAXIMO
                    if ((($dias + $diasAbono) > ($faltaFerias->getQtdiasmaxfe() - $dias_afastados))) {
                        if (!$this->atualizaGozoInvalido($itemGozo, ($faltaFerias->getQtdiasmaxfe() - $diasAbono - $dias_afastados), $vinculo, $faltaFerias, $diasAbono)) {
                            return false;
                        }
                    }
                    
                    if($diasAbono !== 0){
                        $itemGozo->setQtdiasabonoferi($diasAbono);
                        $this->entityManager->persist($itemGozo);
                        $this->entityManager->flush($itemGozo);
                    }
                    
                    $this->_gozo_ferias->addItem($itemGozo, $itemGozo->getNrgozoferias());
                    $this->_diasGozados = $dias;
                    
                    $diasGozo1 = $dias;
                    $diasAbono1 = $diasAbono;
                }
                //Se o vinculo ja tiver gozo
                else if($key == 1){
                    $diasAbono2 = $diasAbono + $diasAbono1;
                    $diasGozo2 = $dias + $diasGozo1;
                    // > DIAS MAXIMO
                    
                    if ($dias <= $tipoFerias->historico->getQtdiasminfe()) {
                        if (!$this->atualizaGozoInvalido($itemGozo, $dias, $vinculo, $faltaFerias, $diasAbono)) {
                            return false;
                        }
                    }
                    
                    if(($diasGozo2 + $diasAbono2) > ($faltaFerias->getQtdiasmaxfe() - $dias_afastados)){
                        if(!$this->atualizaGozoInvalido($itemGozo,  ($faltaFerias->getQtdiasmaxfe() - $diasGozo1 - $diasAbono1 - $dias_afastados),$vinculo,$faltaFerias,0)){
                            return false;
                        }
                        continue;
                    }
                    
                    if($diasAbono !== 0){
                        $itemGozo->setQtdiasabonoferi($diasAbono);
                        $this->entityManager->persist($itemGozo);
                        $this->entityManager->flush($itemGozo);
                    }
                    $this->_gozo_ferias->addItem($itemGozo, $itemGozo->getNrgozoferias());
                    $this->_diasGozados = $dias;
                    
                }
                //Se o vinculo tiver mais de 2 gozos pode no maximo 3
                else{
                    $diasAbono3 = $diasAbono2 + $diasAbono;
                    $diasGozo3 = $dias + $diasGozo2;
                    if(($diasGozo3+$diasAbono3) != ($faltaFerias->getQtdiasmaxfe() - $dias_afastados)){
                        if(!$this->atualizaGozoInvalido($itemGozo,($faltaFerias->getQtdiasmaxfe() - $diasGozo2 - $diasAbono2 - $dias_afastados),$vinculo,$faltaFerias,0)){
                            return false;
                        }
                    }
                    
                    $this->_gozo_ferias->addItem($itemGozo, $itemGozo->getNrgozoferias());
                    $this->_diasGozados = $dias;
                    if($diasAbono !== 0){
                        $itemGozo->setQtdiasabonoferi($diasAbono);
                        $this->entityManager->persist($itemGozo);
                        $this->entityManager->flush($itemGozo);
                    }
                    
                }
            }
        }
        return true;
    }

    public function atualizaGozoInvalido($itemGozo,$diasGozo,$vinculo,$faltaFerias,$diasAbono){
        
        $coletiva = strstr($itemGozo->getDsgozoferias(), 'COLET');

        if($coletiva){
            return true;
        }
        
        $dias = $diasGozo > 0 ? $diasGozo - 1 : 0;
        
        $dtInicio = DateUtil::adicionaIntervalo($itemGozo->getDtinigozoferias(), $dias);
        $itemGozo->setDtfimgozoferias($dtInicio);
        $dtFimGozo = DateUtil::getDataDeString($itemGozo->getDtfimgozoferias());
        $itemGozo->setDtretornoferias(DateUtil::adicionaIntervalo($dtFimGozo, 1));
        $itemGozo->setQtdiasabonoferi($diasAbono);
        $dtinicioverifica = DateUtil::getDataDeString($itemGozo->getDtinigozoferias());
        if($dtinicioverifica->format('d/m/Y') == $dtFimGozo->format('d/m/Y')){
            $this->entityManager->remove($itemGozo);
            MsgCalculo::getInstance()->adicionaMensagem('Dias de direito de gozo excedido para o periodo aquisitivo do ' . $vinculo->getNmvinculom() . ', o vinculo só pode gozar ' . $faltaFerias->getQtdiasmaxfe() . ' dias');
            return false;
        }
        $this->_gozo_ferias->addItem($itemGozo, $itemGozo->getNrgozoferias());
        
        $this->entityManager->persist($itemGozo);
        $this->entityManager->flush($itemGozo);
        $dias = $itemGozo->getDiasDataInicioAteDataFim();
        $this->_diasGozados = $dias;
        return true;
    }

    private function _verificaFeriasColetivas(GpevinculomEntity $vinculo,$dtinigozo,$dtfimgozo,$dtretornoferias,$dtiniproxper,$dsferiascoletivas,$nrsitufuncm){

        $persiste_gozo=false;
        $dt_adm= new TkDateTime($vinculo->getDtadmissaovinc());
        $dtinigozo = new TkDateTime($dtinigozo);
        $intervaloanos= $dtinigozo->yearsAfter($dt_adm);
        $dtfimgozo= new TkDateTime($dtfimgozo);
        $fpaGozoFeriasEntity = new FpagozoferiasEntity();

        if(!$fpaGozoFeriasEntity->validaPersisteGozoFerias($vinculo,$dtinigozo,$dtfimgozo)){
            return;
        }
        
        $diasgozo=$dtinigozo->daysAfter($dtfimgozo);
        $relacaoferias=$this->_ferias->contabilizaFeriasColetivas($vinculo, $dtinigozo, true, $this->_eventom,
            $this->_faltas_intervalo,$this->_jornada_diaria, $this->_nrTipoModalidadeCalc, $this->_nrOcorrenciaCalc,
            $this->_alteracao_situacao_funcional,$this->_mes_competencia,$this->_jornada_semanal,$diasgozo);

        for ($i=0; $i < count($relacaoferias); $i++) {

            $ferias = $this->_ferias->procuraFerias($relacaoferias[$i]['NRFERIAS']);
            if($relacaoferias[$i]['GOZAPERIODO']==FpaFeriasEntity::GOZA_NO_PERIODO_SIM){
                $data_ini_per= new TkDateTime($relacaoferias[$i]['DTINIAQUISICAO']);
                $data_fim_per_aux = new TkDateTime($dtinigozo);
                $data_fim_per_aux->addDay(-1);

                $qtd_doze_avos = $data_ini_per->months($data_fim_per_aux);

                $data_fim_per = clone($data_ini_per);
                $data_fim_per->addMonth($qtd_doze_avos);
                if (($data_fim_per->equals($data_fim_per_aux, TkDateTime::FORMAT_DATE) === true)
                    ||($data_fim_per->isEarlier($data_fim_per_aux, TkDateTime::FORMAT_DATE) === true)
                ) {
                    $dias = $data_fim_per->daysAfter($data_fim_per_aux);
                    if ($dias >= 15) {
                        $qtd_doze_avos++;
                    }
                }
                $nrTipoFerias=$relacaoferias[$i]['TIPOFERIAS'];

                $mult = FpatipoferiasmEntity::retornaDiasDireito($nrTipoFerias);
                $diasTotais = $mult*12;
                if ($relacaoferias[$i]['IDCONTROLFERIAS'] != FpaferiasEntity::IDCONTROLFERIAS_ABERTO){
                    $diasJaGozados = $diasTotais - $relacaoferias[$i]['DIASDIREITO'];
                } else {
                    $diasJaGozados = 0;
                }
                $diasdireito = ceil($qtd_doze_avos*$mult) - $diasJaGozados;
                $dtinigozo = new TkDateTime($dtinigozo);
                $diasgozo=$dtinigozo->daysAfter($dtfimgozo);

                $Art140  =  \Folha\Repositories\FpaValorreferenciam::buscavalor('ART_140_FER_COLET',$this->_nrorg);
                if($Art140==true && $intervaloanos < 1) {
                    if ($this->_nrorg == 1019 && $diasdireito < 10) {
                        $diasdireito = 0;
                    }
                    $diaslicenremun = 0;
                    if ($diasdireito != 0) {

                        if ($diasgozo > $diasdireito) {
                            $diaslicenremun = $diasgozo - $diasdireito;
                            $dtinigozoAux = clone($dtinigozo);
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_INTEGRAL);
                            $ferias->setDtfimaquisicao($dtinigozoAux->addDay(-1));
                            $dtfimgozo->addDay(-$diaslicenremun);
                            $dtinilicen = clone ($dtfimgozo);
                            $dtinilicen->addDay(1);
                            $dtfimlicen = clone($dtinilicen);
                            $dtfimlicen->addDay($diaslicenremun - 1);
                            $persiste_gozo = true;
                            $nrFerias = $relacaoferias[$i]['NRFERIAS'];
                        } else {
                            $dtinigozoAux = clone($dtinigozo);
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL);
                            $ferias->setDtfimaquisicao($dtinigozoAux->addDay(-1));
                            $persiste_gozo = true;
                            $nrFerias = $relacaoferias[$i]['NRFERIAS'];
                        }
                    } else {
                        if ($this->_nrorg != 1019) {
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_INTEGRAL);
                            $dtinigozoAux = clone($dtinigozo);
                            $dtinigozoAux->addDay(-1);
                            $dtinigozo = $dtinigozoAux->isEarlier($relacaoferias[$i]['DTINIAQUISICAO']) ? $dtinigozo : $dtinigozoAux;
                            $ferias->setDtfimaquisicao($dtinigozo);
                        }
                        $diaslicenremun = $diasgozo;
                        $dtinilicen = new TkDateTime($dtinigozo);
                        $dtfimlicen = new TkDateTime($dtfimgozo);
                    }
                    if ($diaslicenremun != 0) {
                        $situfuncm = new \GpesitufuncmEntity();
                        if ($nrsitufuncm != $situfuncm::SITUACAO_FUNCIONAL_NORMAL) {
                            $this->_alteracao_situacao_funcional->incluiAltSituFunc(
                                $vinculo->getNrvinculom(), $vinculo->getNrorg(), $situfuncm::SITUACAO_FUNCIONAL_LICENCA_REMUNERADA, $dtinilicen, $dtfimlicen
                            );

                            $dt_prox_situ_fun = clone ($dtfimlicen);
                            $dt_prox_situ_fun->addDay(1);
                            $this->_alteracao_situacao_funcional->incluiAltSituFunc(
                                $vinculo->getNrvinculom(), $vinculo->getNrorg(), $situfuncm::SITUACAO_FUNCIONAL_NORMAL, $dt_prox_situ_fun, null
                            );
                        }
                    }
                    $databaseferias = new TkDateTime($ferias->getDtfimaquisicao());
                    $databaseferias->addDay(1);
                    $vinculo->historico->atualizaDataBaseFerias($databaseferias);
                    $vinculo->historico->adicionaPersisteHistorico($this->_mes_competencia);
                }else{
                    if($diasgozo>$diasdireito){
                        if($this->_nrorg==1019 && $diasdireito<10){
                            $diasdireito=0;
                        }
                    
                        if($diasdireito!=0){
                            $diaslicenremun=$diasgozo-$diasdireito;
                            $dtinigozoAux = clone($dtinigozo);
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_INTEGRAL);
                            $ferias->setDtfimaquisicao($dtinigozoAux->addDay(-1));
                            $dtfimgozo->addDay(-$diaslicenremun);
                            $dtinilicen = clone ($dtfimgozo);
                            $dtinilicen->addDay(1);
                            $dtfimlicen = clone($dtinilicen);
                            $dtfimlicen->addDay($diaslicenremun-1);
                            $persiste_gozo=true;
                            $nrFerias= $relacaoferias[$i]['NRFERIAS'];
                        }else{
                            if($this->_nrorg!=1019){
                                $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_INTEGRAL);
                                $dtinigozoAux = clone($dtinigozo);
                                $dtinigozoAux->addDay(-1);
                                $dtinigozo = $dtinigozoAux->isEarlier($relacaoferias[$i]['DTINIAQUISICAO'])?$dtinigozo:$dtinigozoAux;
                                $ferias->setDtfimaquisicao($dtinigozo);
                            }
                            $diaslicenremun=$diasgozo;
                            $dtinilicen= new TkDateTime($dtinigozo);
                            $dtfimlicen= new TkDateTime($dtfimgozo);
                        }
                        $situfuncm = new \GpesitufuncmEntity();
                        if($nrsitufuncm != $situfuncm::SITUACAO_FUNCIONAL_NORMAL) {
                            $this->_alteracao_situacao_funcional->incluiAltSituFunc(
                                $vinculo->getNrvinculom(), $vinculo->getNrorg(), $situfuncm::SITUACAO_FUNCIONAL_LICENCA_REMUNERADA, $dtinilicen, $dtfimlicen
                            );

                            $dt_prox_situ_fun = clone ($dtfimlicen);
                            $dt_prox_situ_fun->addDay(1);
                            $this->_alteracao_situacao_funcional->incluiAltSituFunc(
                                $vinculo->getNrvinculom(), $vinculo->getNrorg(), $situfuncm::SITUACAO_FUNCIONAL_NORMAL, $dt_prox_situ_fun, null
                            );
                        }
                        
                    }else{
                        $nrFerias=$relacaoferias[$i]['NRFERIAS'];
                        $persiste_gozo=true;
                    }
                }
                if (($diasgozo>$diasdireito) ) {
				    if (($this->_nrorg!=1019) || ($diasdireito >= 10)){
    					$databaseferias=new TkDateTime($ferias->getDtfimaquisicao());
	    				$databaseferias->addDay(1);
		    			$vinculo->historico->atualizaDataBaseFerias($databaseferias);
		    			$vinculo->historico->adicionaPersisteHistorico($this->_mes_competencia);
			    	}

                }
                $ferias->setQtdiasmaxfe($diasdireito);
                $ferias->persist();
            }
        }

        if($persiste_gozo==true) {
            $this->_gozo_ferias->incluiGozoFerias($vinculo->getNrorg(), $nrFerias, $dtinigozo, $dtfimgozo, 0,
                $dtretornoferias, 'N',$dsferiascoletivas);
        }
    }

    private function _cancelaFeriasColetivas(GpevinculomEntity $vinculo, $dtinigozo, $dtfimgozo, $dtretornoferias, $dsferiascoletivas){
        $persiste_gozo=false;

        $dt_adm= new TkDateTime($vinculo->getDtadmissaovinc());
        $dtinigozo=new TkDateTime($dtinigozo);
        $intervaloanos= $dtinigozo->yearsAfter($dt_adm);
        $diasdireito=0;
        $qtd_doze_avos=0;
        $diaslicenremun=0;

        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());

        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $itemGozo = $this->_gozo_ferias->procuraGozoFerias($dtinigozo);
        if(is_object($itemGozo)){
            $ferias = $this->_ferias->procuraFerias($itemGozo->getNrferias());
        }

        if(is_object($ferias)) {
            if ($ferias->getIdcontrolferias() != FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL) {
                
                $data_ini_per = new TkDateTime($ferias->getDtiniaquisicao());
                $data_fim_per_aux = new TkDateTime($dtinigozo);
                $data_fim_per_aux->addDay(-1);

                $qtd_doze_avos = $data_ini_per->months($data_fim_per_aux);

                $data_fim_per = clone($data_ini_per);
                $data_fim_per->addMonth($qtd_doze_avos);
                if (($data_fim_per->equals($data_fim_per_aux, TkDateTime::FORMAT_DATE) === true)
                    || ($data_fim_per->isEarlier($data_fim_per_aux, TkDateTime::FORMAT_DATE) === true)
                ) {
                    $dias = $data_fim_per->daysAfter($data_fim_per_aux);
                    if ($dias >= 15) {
                        $qtd_doze_avos++;
                    }
                }
                
                $nrTipoFerias = $ferias->getNrtipoferias();
                $mult = $diasdireito = FpatipoferiasmEntity::retornaDiasDireito($nrTipoFerias);
                $diasdireito = ceil($qtd_doze_avos * $mult);
                $dtinigozo = new TkDateTime($dtinigozo);
                $diasgozo = $dtinigozo->daysAfter($dtfimgozo);

                $dtFimAquisitivo = new TkDateTime($ferias->getDtfimaquisicao());
                if ($dtFimAquisitivo->isEarlier($this->_mes_competencia)) {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO);
                } else {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ABERTO);
                }
                $itemGozoAnterior = $this->_gozo_ferias->procuraGozoFeriasAnterior($dtinigozo,$ferias->getNrferias());
                if (is_object($itemGozoAnterior)) {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL);
                }
                $Art140 = \Folha\Repositories\FpaValorreferenciam::buscavalor('ART_140_FER_COLET', $this->_nrorg);
                if ($Art140 == true && $intervaloanos < 1) {
                    
                    if ($this->_nrorg == 1019 && $diasdireito < 10) {
                        $diasdireito = 0;
                    }

                    $dtFimAquisicao = new TkDateTime($ferias->getDtiniaquisicao());
                    $dtFimAquisicao->addYear(1)->addDay(-1);
                    $ferias->setDtfimaquisicao($dtFimAquisicao);

                    if ($diasdireito != 0) {
                        $diaslicenremun = $diasgozo - $diasdireito;
                        $dtfimgozo = new TkDateTime($dtfimgozo);

                        $dtfimgozo->addDay(-$diaslicenremun);

                        $dtinilicen = clone ($dtfimgozo);
                        $dtinilicen->addDay(1);
                        $dtfimlicen = clone($dtinilicen);
                        $dtfimlicen->addDay($diaslicenremun - 1);
                        $persiste_gozo = true;
                        $nrFerias = $ferias->getNrferias();
                    } else {
                        $dtinigozoAux = clone($dtinigozo);
                        $dtinigozoAux->addDay(-1);
                        $dtinigozo = $dtinigozoAux->isEarlier($ferias->getDtiniaquisicao()) ? $dtinigozo : $dtinigozoAux;

                        $diaslicenremun = $diasgozo;
                        $dtinilicen = new TkDateTime($dtinigozo);
                        $dtfimlicen = new TkDateTime($dtfimgozo);
                    }
                    $dt_situ_fun = new TkDateTime($itemGozo->getDtfimgozoferias());
                    $dt_situ_fun->addDay(1);

                    $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
                        $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
                    );

                    $itemAltSituFuncLic = $this->_alteracao_situacao_funcional->procuraAltSituFunc(
                        $dt_situ_fun, 17
                    );
                    if (is_object($itemAltSituFuncLic)) {
                        $dt_situ_normal = new TkDateTime($itemAltSituFuncLic->getDtfimsitufunc());
                        $dt_situ_normal->addDay(1);

                        GpealtesitufuncEntity::deletaAltSituFunc($itemAltSituFuncLic->getNraltesitufunc(), $itemAltSituFuncLic->getNrorg(), $itemAltSituFuncLic->getNrvinculom());
                        $itemAltSituFuncNorm = $this->_alteracao_situacao_funcional->procuraAltSituFunc(
                            $dt_situ_normal, 1
                        );
                        if (is_object($itemAltSituFuncNorm)) {
                            GpealtesitufuncEntity::deletaAltSituFunc($itemAltSituFuncNorm->getNraltesitufunc(), $itemAltSituFuncNorm->getNrorg(), $itemAltSituFuncNorm->getNrvinculom());
                        }
                    }
                } else {

                if ($diasdireito < $diasgozo) {
                    if($this->_nrorg==1019 && $diasdireito<10){
                        $diasdireito=0;
                    }

                    $dtFimAquisicao = new TkDateTime($ferias->getDtiniaquisicao());
                    $dtFimAquisicao->addYear(1)->addDay(-1);
                    $ferias->setDtfimaquisicao($dtFimAquisicao);

                    if ($diasdireito != 0) {
                        $diaslicenremun = $diasgozo - $diasdireito;
                        $dtfimgozo = new TkDateTime($dtfimgozo);

                        $dtfimgozo->addDay(-$diaslicenremun);

                        $dtinilicen = clone ($dtfimgozo);
                        $dtinilicen->addDay(1);
                        $dtfimlicen = clone($dtinilicen);
                        $dtfimlicen->addDay($diaslicenremun - 1);
                        $persiste_gozo = true;
                        $nrFerias = $ferias->getNrferias();
                    } else {
                        $dtinigozoAux = clone($dtinigozo);
                        $dtinigozoAux->addDay(-1);
                        $dtinigozo = $dtinigozoAux->isEarlier($ferias->getDtiniaquisicao()) ? $dtinigozo : $dtinigozoAux;

                        $diaslicenremun = $diasgozo;
                        $dtinilicen = new TkDateTime($dtinigozo);
                        $dtfimlicen = new TkDateTime($dtfimgozo);
                    }
                    $dt_situ_fun = new TkDateTime($itemGozo->getDtfimgozoferias());
                    $dt_situ_fun->addDay(1);

                    $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
                        $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
                    );

                    $itemAltSituFuncLic = $this->_alteracao_situacao_funcional->procuraAltSituFunc(
                        $dt_situ_fun, 17
                    );
                    if (is_object($itemAltSituFuncLic)) {
                        $dt_situ_normal = new TkDateTime($itemAltSituFuncLic->getDtfimsitufunc());
                        $dt_situ_normal->addDay(1);

                        GpealtesitufuncEntity::deletaAltSituFunc($itemAltSituFuncLic->getNraltesitufunc(), $itemAltSituFuncLic->getNrorg(), $itemAltSituFuncLic->getNrvinculom());
                    
                        $itemAltSituFuncNorm = $this->_alteracao_situacao_funcional->procuraAltSituFunc(
                            $dt_situ_normal, 1
                        );
                        if (is_object($itemAltSituFuncNorm)) {
                            GpealtesitufuncEntity::deletaAltSituFunc($itemAltSituFuncNorm->getNraltesitufunc(), $itemAltSituFuncNorm->getNrorg(), $itemAltSituFuncNorm->getNrvinculom());
                        }
                    }
                } else {
                    $nrFerias = $ferias->getNrferias();
                    $persiste_gozo = true;
                }
                }
                $ferias->persist();
            } else {
                $dtFimAquisitivo = new TkDateTime($ferias->getDtfimaquisicao());

                $Art140 = \Folha\Repositories\FpaValorreferenciam::buscavalor('ART_140_FER_COLET', $this->_nrorg);
                if ($Art140 == true && $intervaloanos < 1) {
                    $dtFimAquisitivo = new TkDateTime($ferias->getDtiniaquisicao());
                    $dtFimAquisitivo->addYear(1)->addDay(-1);
                    $ferias->setDtfimaquisicao($dtFimAquisitivo);
                }
                if ($dtFimAquisitivo->isEarlier($this->_mes_competencia)) {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO);
                } else {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ABERTO);
                }
                $itemGozoAnterior = $this->_gozo_ferias->procuraGozoFeriasAnterior($dtinigozo,$ferias->getNrferias());
                if (is_object($itemGozoAnterior)) {
                    $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL);
                }
                $ajustaSaldoProxPeriodo = true;
                $ferias->persist();
            }

            if ($intervaloanos == 0) {
                $databaseferias = new TkDateTime($vinculo->getDtadmissaovinc());
                
                $vinculo->historico->atualizaDataBaseFerias($databaseferias);
                $vinculo->historico->adicionaPersisteHistorico($this->_mes_competencia);
            }

            $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
            $itemGozo = $this->_gozo_ferias->procuraGozoFerias($dtinigozo);

            if (is_object($itemGozo)) {
                if ($itemGozo->getDsgozoferias() == $dsferiascoletivas) {
                    FpagozoferiasEntity::deletaGozoFerias($itemGozo->getNrgozoferias(), $itemGozo->getNrorg(), $itemGozo->getNrferias());
                }
            }
        }
    }

    private function _indenizaPeriodoDissidio($vinculo, $itenscalculo){
        
        $fpaparamsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->findOneBy(
            array('nrorg' => $vinculo->getNrorg(), 'nrestruturam' => $vinculo->historico->getNrestrutsind()));
            
        if(is_object($fpaparamsindicato) && $fpaparamsindicato->getDtbasesindical()!= null ) {
            $dtDissidio = DateUtil::setYear($fpaparamsindicato->getDtbasesindical(), $this->_mes_competencia->format('Y'));
            $dtLimFimDissidio = clone($dtDissidio);
            $dtLimFimDissidio = DateUtil::subtraiIntervalo($dtDissidio, 1);
            $dtLimIniDissidio = DateUtil::subtraiIntervalo($dtDissidio, 30);
             
            if($vinculo->getNrtpdemissao()==FpaTpdemissaoEntity::SEM_JUSTA_CAUSA_EMPREGADOR){

                $dtRescisao = $vinculo->getDtrescisaovinc();
                $dtAviso = $vinculo->getDtavisoprevio();
                if (!(empty($dtRescisao))&&!(empty($dtAviso))) {
                    
                    
                    $dtRescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
                    $dtRescisaoProj = $dtRescisao;
                    $dtAviso = DateUtil::getDataDeString($vinculo->getDtavisoprevio());

                    if($dtAviso < $dtRescisao){
                        $dtRescisaoProj = DateUtil::adicionaIntervalo($dtRescisaoProj, $this->_nr_compl_dias_aviso);
                    }else{
                        $dtRescisaoProj = DateUtil::adicionaIntervalo($dtRescisaoProj, 30+$this->_nr_compl_dias_aviso);
                    }
                    if ((($dtRescisaoProj->format('d/m/Y') === $dtLimIniDissidio->format('d/m/Y')) || $dtRescisaoProj > $dtLimIniDissidio) 
                    && ($dtRescisaoProj->format('d/m/Y') === $dtLimFimDissidio->format('d/m/Y') || $dtRescisaoProj < $dtLimFimDissidio)) {
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_INDENIZ_DISSIDIO, $this->_eventom, $this->_nrorg
                        );
                        $itenscalculo->geraEvento($evento, null, 0, 100, 1);
                    }else{
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_INDENIZ_DISSIDIO, $this->_eventom, $this->_nrorg
                        );
                        $itenscalculo->geraEvento($evento, null, 0, 0, 1);
                    }
                }
            }
        }
    }
    
    private function _atribuiIteCalcEspecificoRescisao($tp_calc_mov){

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_ferias_vencidas = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_VENC;
            $this->_ferias_proporcionais = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_PROP;
            $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_PROV_13SAL;
        } else {
            $this->_ferias_vencidas = FpatipomovimentEntity::TP_MOV_FERIAS_VENC_RESC;
            $this->_ferias_proporcionais = FpatipomovimentEntity::TP_MOV_FERIAS_PROP_RESC;
            $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_13SAL_RESC;
            $this->_aviso_previo = FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC;
            $this->_media_mensal = FpatipomovimentEntity::TP_MOV_MEDIA_MENSAL;
        }

        try{
            $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas);
            foreach ($obj_tp_calc_mov as $obj) {
                $instancia = $obj->getInstancia();
                $instancia->setNrvinculom($this->nrVinculom);
                
                $this->_itens_ferias_vencidas[] =  $instancia;
            }
        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Ferias Vencidas PREPARACAO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem('Ferias Vencidas - '.$e->getMessage());
        }

        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_proporcionais)
            );
            $this->_itens_ferias_proporcionais =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_ferias_proporcionais->setNrvinculom($this->nrVinculom);
        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Férias Proporcionais PREPARACAO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem('Férias Proporcionais - '.$e->getMessage());
        }

        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_decimo_terceiro_sal)
            );
            $this->_itens_13sal =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_13sal->setNrvinculom($this->nrVinculom);

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - 13 Salário PREPARACAO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem('13º Salário - '.$e->getMessage());
        }
        if ($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            try {
                $obj_tp_calc_mov = current(
                    $tp_calc_mov->retornaPosicaoTpMov($this->_aviso_previo)
                );
                $this->_itens_aviso_previo = $obj_tp_calc_mov->getInstancia();
                $this->_itens_aviso_previo->setNrvinculom($this->nrVinculom);
                
            } catch (Exception $e) {
                $message = $e->getMessage();
                $message .= ' - Aviso Prévio PREPARACAO.PHP';
                MsgCalculo::getInstance()->adicionaMensagem('Aviso Prévio - ' . $e->getMessage());
            }

            try {
                $obj_tp_calc_mov = current(
                    $tp_calc_mov->retornaPosicaoTpMov($this->_media_mensal)
                );
                $this->_itens_media_mensal = $obj_tp_calc_mov->getInstancia();
                $this->_itens_media_mensal->setNrvinculom($this->nrVinculom);

            } catch (Exception $e) {
                $message = $e->getMessage();
                $message .= ' - Média no mensal da rescisão PREPARACAO.PHP';
                MsgCalculo::getInstance()->adicionaMensagem('Média Mensal - ' . $e->getMessage());
            }
        }
    }

    private function _atribuiIteCalcEspecificoProvisao($tp_calc_mov){

        $this->_ferias_vencidas = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_VENC;
        try{
            $obj_tp_calc_mov = $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_vencidas);
            foreach ($obj_tp_calc_mov as $obj) {
                $instancia = $obj->getInstancia();
                $instancia->setNrvinculom($this->nrVinculom);
                
                $this->_itens_ferias_vencidas[] =  $instancia;
            }
            
        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Ferias Vencidas PREPARACAO.PHP';
            
            MsgCalculo::getInstance()->adicionaMensagem('Ferias Vencidas - '.$e->getMessage());
        }

        $this->_ferias_proporcionais = FpatipomovimentEntity::TP_MOV_PROV_FERIAS_PROP;
        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_ferias_proporcionais)
            );
            $this->_itens_ferias_proporcionais =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_ferias_proporcionais->setNrvinculom($this->nrVinculom);

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - Férias Proporcionais PREPARACAO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem('Férias Proporcionais - '.$e->getMessage());
        }
        
        $this->_decimo_terceiro_sal = FpatipomovimentEntity::TP_MOV_PROV_13SAL;
        try{
            $obj_tp_calc_mov = current(
                $tp_calc_mov->retornaPosicaoTpMov($this->_decimo_terceiro_sal)
            );
            $this->_itens_13sal =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_13sal->setNrvinculom($this->nrVinculom);

        } catch(Exception $e){
            $message = $e->getMessage();
            $message .= ' - 13 Salário PREPARACAO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem('13º Salário - '.$e->getMessage());
        }
    }
    
}