<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class CCTRepository {
    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function setCCT($params){
        $sql= $this->entityManager->getConnection()->prepare(
            "INSERT INTO FPA_CADASTROCCT (NRORG,
            NRCADASTROCCT,
            IDATIVO,
            NRESTRUTURAM,
            DTANOBASECCT,
            DTINIVIGENCIACCT,
            DTFINVIGENCIACCT,
            DTINCLUSAO,
            CDOPERINCLUSAO,
            NRORGINCLUSAO,
            DTULTATU,
            CDOPERULTATU,
            NRORGULTATU) VALUES (:P_NRORG,
            :P_NRCADASTROCCT,
            :P_IDATIVO,
            :P_NRESTRUTURAM,
            :P_DTANOBASECCT,
            :P_DTINIVIGENCIACCT,
            :P_DTFINVIGENCIACCT,
            :P_DTINCLUSAO,
            :P_CDOPERINCLUSAO,
            :P_NRORGINCLUSAO,
            :P_DTULTATU,
            :P_CDOPERULTATU,
            :P_NRORGULTATU
            )"    
        );
        $sql->execute($params);
    }
    
    public function getItens($nrorg,$nrcadastroCCT){
        $sql = $this->entityManager->getConnection()->prepare("SELECT * FROM FPA_ITCADASTROCCT WHERE NRORG = :P_NRORG AND NRCADASTROCCT = :P_NRCADASTROCCT");
        $sql->execute(
            array(
                "P_NRORG"=>$nrorg,
                "P_NRCADASTROCCT"=>$nrcadastroCCT
            )
        );
        return $sql->fetchAll();
    }
    
    public function setitemCCT($params){
        $sql= $this->entityManager->getConnection()->prepare(
            "INSERT INTO FPA_ITCADASTROCCT 
            (NRORG,
            NRCADASTROCCT,
            NRITCADASTROCCT,
            NRTIPOITEMCCT,
            DSITEMCCT,
            DSLEGISLACAOITCCT,
            NROCUPACAOM,
            NRESCALATRABM,
            NRSITUFUNCM,
            NRTPDEMISSAO,
            NREVENTOM,
            NRFAIXATABFOLHA,
            NRVALORREFERENCIAM,
            VRPISOITCCT,
            VRTETOITCCT,
            DTINIITEMCCT,
            DTFINITEMCCT,
            VRPERCENTUALITCCT,
            VRITEMCCT,
            DSINIINTERVALOCCT,
            DSFININTERVALOCCT,
            VRIDADEMINIMACCT,
            VRIDADEMAXIMACCT,
            QTDEMESESITCCT,
            QTDEANOMINCCT,
            QTDEANOMAXCCT,
            QTDIASESTABITCCT,
            DTINCLUSAO,
            CDOPERINCLUSAO,
            NRORGINCLUSAO,
            DTULTATU,
            CDOPERULTATU,
            NRORGULTATU) VALUES (:P_NRORG,
            :P_NRCADASTROCCT,
            :P_NRITCADASTROCCT,
            :P_NRTIPOITEMCCT,
            :P_DSITEMCCT,
            :P_DSLEGISLACAOITCCT,
            :P_NROCUPACAOM,
            :P_NRESCALATRABM,
            :P_NRSITUFUNCM,
            :P_NRTPDEMISSAO,
            :P_NREVENTOM,
            :P_NRFAIXATABFOLHA,
            :P_NRVALORREFERENCIAM,
            :P_VRPISOITCCT,
            :P_VRTETOITCCT,
            :P_DTINIITEMCCT,
            :P_DTFINITEMCCT,
            :P_VRPERCENTUALITCCT,
            :P_VRITEMCCT,
            :P_DSINIINTERVALOCCT,
            :P_DSFININTERVALOCCT,
            :P_VRIDADEMINIMACCT,
            :P_VRIDADEMAXIMACCT,
            :P_QTDEMESESITCCT,
            :P_QTDEANOMINCCT,
            :P_QTDEANOMAXCCT,
            :P_QTDIASESTABITCCT,
            :P_DTINCLUSAO,
            :P_CDOPERINCLUSAO,
            :P_NRORGINCLUSAO,
            :P_DTULTATU,
            :P_CDOPERULTATU,
            :P_NRORGULTATU
            )"    
        );
        $sql->execute($params);

    }
    
    public function getBeneficiosCCT($nrorg,$nrcadastroCCT){
        $sql = $this->entityManager->getConnection()->prepare("SELECT * FROM VAB_BENEFICIOCCT WHERE NRORG = :P_NRORG AND NRCADASTROCCT = :P_NRCADASTROCCT");
        $sql->execute(
            array(
                "P_NRORG"=>$nrorg,
                "P_NRCADASTROCCT"=>$nrcadastroCCT
            )
        );
        return $sql->fetchAll();
    }
    
    public function setBeneficioCCT($params){
        $sql= $this->entityManager->getConnection()->prepare(
            "INSERT INTO VAB_BENEFICIOCCT 
            (
                NRORG,                  
                NRBENEFICIOCCT,         
                NRCADASTROCCT,          
                NRTPBENEFICIO,          
                NRIDADEMAXSUBFILHOS,                     
                SEXOSUBSIDIOFILHO,               
                NRIDADEMAXSUBDEP,                        
                SEXOSUBSIDIODEP,                 
                NREVETITULARVINC,                        
                NRTIPOPARTICIPATITULAR,          
                NRTABFAIXASALTIT,                
                VRTITULARSIND,                   
                VRTETOTITULARSIND,               
                VRPISOTITULARSIND,               
                NREVEDEPEVINC,                           
                NRTIPOPARTICIPADEP,              
                NRTABFAIXASALDEP,                
                VRDEPSIND,                       
                VRPISODEPSIND,                   
                VRTETODEPSIND,                   
                IDATIVO,
                NREVENTOMENSA,
                NREVENTOMENSADEP,
                VRTETOTITULARMENS,
                VRPISOTITULARMENS,
                VRLINEARBENEFICIO,
                VRLINEARBENEFICIODEP,
                IDPROPADMIS,
                IDPROPRESC,
                QTDIASMINMES,
                QTDIASMAXFALTAS,
                QTDIASMAXATEST,
                QTMESMAXAFAST,
                VRMULTIPLICADOR,
                DSVINCULOEMPREG,
                DSINCIDEVENTO,
                VRFIXACRESDESC,
                VRPERACRESCDESC,
                IDNAOGERBENVINCEXP,
                IDNAOGERABENPEREXP,
                IDNAOGERABENRESC,
                VRPARTICIPATITULAR,
                VRPISOTITULAR,
                VRTETOTITULAR,
                VRPARTICIPADEPE,
                VRPISODEP,
                VRTETODEP,
                QTMAXHSREDUZIDA,
                VRHSREDUZIDA,
                DSINCIDEVENPERDER,
                QTMESRETROCMULT,
                QTMESRETROCSEMBEN,
                DSAFASTAMENTO1,
                IDGERADESCAFAST1,
                DSAFASTAMENTO2,
                QTMESMAXAFAST2,
                IDGERADESCAFAST2,
                DTINCLUSAO,
                DTULTATU,                                  
                NRORGINCLUSAO,                           
                CDOPERINCLUSAO,                    
                NRORGULTATU,                             
                CDOPERULTATU,                     
                DSAFASTAMENTO3,
                QTMESRETROCDIASTRAB
            ) VALUES (
                :P_NRORG,                  
                :P_NRBENEFICIOCCT,         
                :P_NRCADASTROCCT,          
                :P_NRTPBENEFICIO,          
                :P_NRIDADEMAXSUBFILHOS,                     
                :P_SEXOSUBSIDIOFILHO,               
                :P_NRIDADEMAXSUBDEP,                        
                :P_SEXOSUBSIDIODEP,                 
                :P_NREVETITULARVINC,                        
                :P_NRTIPOPARTICIPATITULAR,          
                :P_NRTABFAIXASALTIT,                
                :P_VRTITULARSIND,                   
                :P_VRTETOTITULARSIND,               
                :P_VRPISOTITULARSIND,               
                :P_NREVEDEPEVINC,                           
                :P_NRTIPOPARTICIPADEP,              
                :P_NRTABFAIXASALDEP,                
                :P_VRDEPSIND,                       
                :P_VRPISODEPSIND,                   
                :P_VRTETODEPSIND,                   
                :P_IDATIVO,
                :P_NREVENTOMENSA,
                :P_NREVENTOMENSADEP,
                :P_VRTETOTITULARMENS,
                :P_VRPISOTITULARMENS,
                :P_VRLINEARBENEFICIO,
                :P_VRLINEARBENEFICIODEP,
                :P_IDPROPADMIS,
                :P_IDPROPRESC,
                :P_QTDIASMINMES,
                :P_QTDIASMAXFALTAS,
                :P_QTDIASMAXATEST,
                :P_QTMESMAXAFAST,
                :P_VRMULTIPLICADOR,
                :P_DSVINCULOEMPREG,
                :P_DSINCIDEVENTO,
                :P_VRFIXACRESDESC,
                :P_VRPERACRESCDESC,
                :P_IDNAOGERBENVINCEXP,
                :P_IDNAOGERABENPEREXP,
                :P_IDNAOGERABENRESC,
                :P_VRPARTICIPATITULAR,
                :P_VRPISOTITULAR,
                :P_VRTETOTITULAR,
                :P_VRPARTICIPADEPE,
                :P_VRPISODEP,
                :P_VRTETODEP,
                :P_QTMAXHSREDUZIDA,
                :P_VRHSREDUZIDA,
                :P_DSINCIDEVENPERDER,
                :P_QTMESRETROCMULT,
                :P_QTMESRETROCSEMBEN,
                :P_DSAFASTAMENTO1,
                :P_IDGERADESCAFAST1,
                :P_DSAFASTAMENTO2,
                :P_QTMESMAXAFAST2,
                :P_IDGERADESCAFAST2,
                :P_DTINCLUSAO,
                :P_DTULTATU,                                  
                :P_NRORGINCLUSAO,                           
                :P_CDOPERINCLUSAO,                    
                :P_NRORGULTATU,                             
                :P_CDOPERULTATU,                     
                :P_DSAFASTAMENTO3,
                :P_QTMESRETROCDIASTRAB
            )"    
        );
        $sql->execute($params);
    }
    
} 
