<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Geral\Repository\ParametrizacaoEsocialRepository;
use HCM\Util\HCMParameters;


class ParametrizacaoEsocialService {

    public function __construct(EntityManager $entityManager, ParametrizacaoEsocialRepository $parametrizacaoEsocialRepository, HCMParameters $hcmParameters)
    {
        $this->entityManager = $entityManager;
        $this->parametrizacaoEsocialRepository = $parametrizacaoEsocialRepository;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function existeParametrizacaoEsocial($row)
    {   
        $existeParametrizacaoEsocial = $this->entityManager->getRepository(Repositories::ESO_RUBRICA)->findOneBy(array('nreventom' => $row["NREVENTOM"], 'nrorg' => $row["NRORG"], 'nrtipomoviment' => $row["NRTIPOMOVIMENT"]));
        return  $existeParametrizacaoEsocial;
    }

    public function cadastroAutomaticoParametrizacaoEsocial($nreventom, $savecrud = false)
    {   
        $existeNaturezaRubricaEvento = self::buscaEventoComNaturezaRubrica($nreventom);
        if(empty($existeNaturezaRubricaEvento)) {
            if($savecrud) {
                return;
            } else {
                return 'erroNaturezaRubrica';
            }
            
        }

        $arrayParametrizacaoEsocial = $this->parametrizacaoEsocialRepository->geraInsertParametrizacaoEsocial($nreventom);
        
        if(!empty($arrayParametrizacaoEsocial)) {
            $insereParametrizacaoEsocial = self::insereParametrizacaoEsocial($arrayParametrizacaoEsocial);
            return $insereParametrizacaoEsocial;
        }

        return;
    }

    public function insereParametrizacaoEsocial($arrayParametrizacaoEsocial)
    {   
        $save = false;
        foreach ($arrayParametrizacaoEsocial as $parametrizacaoEsocial) {
            $parametrizacaoEsocial["NRORG"] = $this->hcmParameters->getNrorgTrabalho();
            $existeParametrizacaoEsocial = self::existeParametrizacaoEsocial($parametrizacaoEsocial);
            if(!empty($existeParametrizacaoEsocial)){
                continue;
            }

            $novo = $this->parametrizacaoEsocialRepository->insereParametrizacaoEsocial($parametrizacaoEsocial);
            if(!empty($novo)) {
                $save = true;
            }
        }

        return $save;
    }

    public function buscaEventoComNaturezaRubrica($nreventom)
    {   
        $existeNaturezaRubricaEvento = $this->parametrizacaoEsocialRepository->buscaEventoComNaturezaRubrica($nreventom);
        return $existeNaturezaRubricaEvento ;
    }
}