<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;


class ProcessoTrabService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, \HCM\Geral\Repository\ProcessoTrabRepository $processoTrabRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->processoTrabRepository = $processoTrabRepository;
    }
    
    public function validadelete($dataset) {
        $items = [];
        $items = array_merge($this->validaDeleteEstruturaMsg($dataset), $items);
        $items = array_merge($this->validaDeleteItemsMsg($dataset), $items);
        return $items;
    }
    
    public function validaDeleteEstruturaMsg($dataset) {
        $items = $this->processoTrabRepository->validadeleteEstrutura($dataset);
        $msg = array_map(function ($item){
          return ['msg' => "O processo se encontra relacionado à estrutura de número ${item['NRESTRUTURAM']} na(s) competência(s) ${item['COMPETENCIAS']}"]; 
        }, $items);
        return $msg;
    }
    
    public function validaDeleteItemsMsg($dataset) {
        $items = $this->processoTrabRepository->validadelete($dataset);
        if(!empty($items)) {
            return [['msg' => "Existem itens relacionados a este registro, favor excluí-los."]];
        }
        return [];
    }
    
}