<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class GheHomogenExposicaoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    public function existeGHE($row, $nrEstruturam, $nrOcupacaom, $fatorRisco)
{
    try {
        $sql = $this->entityManager->getConnection()->prepare(
            "SELECT *
             FROM SST_GHERISCO
             WHERE NRESTRUTURAM = :P_NRESTRUTURAM
               AND NRORG = :P_NRORG
               AND NROCUPACAOM = :P_NROCUPACAOM
               AND NRFATORRISCO = :P_NRFATORRISCO"
        );

        $sql->execute(
            array(
                'P_NRESTRUTURAM' => $nrEstruturam,
                'P_NROCUPACAOM' => $nrOcupacaom,
                'P_NRFATORRISCO' => $fatorRisco,
                'P_NRORG' => $row['NRORG'],
            )
        );

        return $sql->fetch();  
    } catch (\Exception $e) {
        throw $e;
    }
}
    
} 

