<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class PerfilepiRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    public function buscaEpi($nrorg, $nrperfilepi)
    {
        try {
            $sql = $this->entityManager->getConnection()->prepare( 
                "SELECT EPI.*
                 FROM SST_PERFILEPI PEPI
                 JOIN SST_ITEMPERFILEPI ITEPI ON ITEPI.NRORG = PEPI.NRORG
                                                AND ITEPI.NRPERFILEPI = PEPI.NRPERFILEPI
                 JOIN  SST_EPI EPI ON EPI.NRORG = ITEPI.NRORG
                                                AND EPI.NREPI = ITEPI.NREPI
                    WHERE  PEPI.NRORG = :P_NRORG
                    AND PEPI.NRPERFILEPI = :P_NRPERFILEPI"
                    );
                    
                    $sql->execute(
                        array(
                            'P_NRORG' => $nrorg,
                            'P_NRPERFILEPI' =>  $nrperfilepi,
                        )
                    );
                    
                    return $sql->fetchAll();  
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function buscaPerfilEpiAssocEstrutura($nrorg, $nrperfilepi)
    {
        try {
            $sql = $this->entityManager->getConnection()->prepare( 
                "SELECT PEE.*
                 FROM SST_PERFILEPIESTRUTURA PEE
                    WHERE  PEE.NRORG = :P_NRORG
                    AND PEE.NRPERFILEPI = :P_NRPERFILEPI"
                    );
                    
                    $sql->execute(
                        array(
                            'P_NRORG' => $nrorg,
                            'P_NRPERFILEPI' =>  $nrperfilepi,
                        )
                    );
                    
                    return $sql->fetchAll();  
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function buscaPerfilEpiAssocVinculo($nrorg, $nrperfilepi)
    {
        try {
            $sql = $this->entityManager->getConnection()->prepare( 
                "SELECT PEV.*
                FROM SST_PERFILEPIVINCULO PEV
                   WHERE  PEV.NRORG = :P_NRORG
                   AND PEV.NRPERFILEPI = :P_NRPERFILEPI"
                   );
                    
                    $sql->execute(
                        array(
                            'P_NRORG' => $nrorg,
                            'P_NRPERFILEPI' =>  $nrperfilepi,
                        )
                    );
                    
                    return $sql->fetchAll();  
        } catch (\Exception $e) {
            throw $e;
        }
    }
} 

